package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.hyjavaapex.model.common.General;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BarWithMarkers extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		
		chartOptions.getPlotOptions().getBar().setHorizontal(true);
		chartOptions.setColors(Arrays.asList(new Color("#00E396")));
		
		chartOptions.getDataLabels().setFormatter(
				new Function("const goals = opt.w.config.series[opt.seriesIndex].data[opt.dataPointIndex].goals\r\n"
				+ "if (goals && goals.length) {\r\n"
				+ "    return `${val} / ${goals[0].value}`\r\n"
				+ "}\r\n"
				+ "return val", "val", "opt"));
		
		chartOptions.getLegend().setShow(true).setShowForSingleSeries(true)
			.setCustomLegendItems(Arrays.asList("Actual", "Expected"))
			.getMarkers().setFillColors(Arrays.asList(new Color("#00E396"), new Color("#775DD0")));

		Series series = new Series();
		series.setName("Actual");
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("2011").setY(12)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 14, strokeWidth: 2, strokeDashArray: 2, strokeColor: '#775DD0' }"))),
			new Data().setX("2012").setY(44)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 54, strokeWidth: 5, strokeHeight: 10, strokeColor: '#775DD0' }"))),
			new Data().setX("2013").setY(54)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 52, strokeWidth: 10, strokeHeight: 0, strokeLineCap: 'round', strokeColor: '#775DD0' }"))),
			new Data().setX("2014").setY(66)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 61, strokeWidth: 10, strokeHeight: 0, strokeLineCap: 'round', strokeColor: '#775DD0' }"))),
			new Data().setX("2015").setY(81)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 66, strokeWidth: 10, strokeHeight: 0, strokeLineCap: 'round', strokeColor: '#775DD0' }"))),
			new Data().setX("2016").setY(67)
				.setGoals(Arrays.asList(new General("{ name: 'Expected', value: 70, strokeWidth: 5, strokeHeight: 10, strokeColor: '#775DD0' }")))
				));

		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}