package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BarWithNegativeValues extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR).setStacked(true);
		chartOptions.setColors(Arrays.asList(new Color("#008FFB"), new Color("#FF4560")));
		chartOptions.getPlotOptions().getBar().setHorizontal(true).setBarHeight("80%");
		
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setWidth(1).setColors(Arrays.asList(new Color("#fff")));
		chartOptions.getGrid().getXaxis().getLines().setShow(false);
		
		chartOptions.getYaxisSingle().setMin(-5).setMax(5).getTitle().setText("Age");
		
		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList(
				"85+", "80-84", "75-79", "70-74", "65-69", "60-64", "55-59", "50-54", "45-49", 
				"40-44", "35-39", "30-34", "25-29", "20-24", "15-19", "10-14", "5-9", "0-4"))
			.getTitle().setText("Percent");
		chartOptions.getXaxis().getLabels().setFormatter(
				new Function("return Math.abs(Math.round(val)) + \"%\"", "val"));

		chartOptions.getTitle().setText("Mauritius population pyramid 2011");

		chartOptions.getTooltip().setShared(false);
		chartOptions.getTooltip().getX().setFormatter(new Function("return val", "val"));
		chartOptions.getTooltip().getY().setFormatter(new Function("return Math.abs(val) + \"%\"", "val"));
		
		Series series = new Series();
		series.setName("Males");
		series.setDataAsArrayNumber(Arrays.asList(
				0.4, 0.65, 0.76, 0.88, 1.5, 2.1, 2.9, 3.8, 3.9, 4.2, 4, 
				4.3, 4.1, 4.2, 4.5, 3.9, 3.5, 3));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Females");
		series.setDataAsArrayNumber(Arrays.asList(
				-0.8, -1.05, -1.06, -1.18, -1.4, -2.2, -2.85, -3.7, 
				-3.96, -4.22, -4.3, -4.4, -4.1, -4, -4.1, -3.4, -3.1, -2.8));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}