package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AutoSelected;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BrushChart extends DemoChartBase {
	private static final long serialVersionUID = 1L;
	private int chartid = 0;


	public Apexchart lineChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("65%").setType(ChartType.LINE).setId("chart" + chartid)
			.getToolbar().setAutoSelected(AutoSelected.PAN).setShow(false);
		
		chartOptions.setColors(Arrays.asList(new Color("#546E7A")));
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setWidth(3);
		
		chartOptions.getFill().setOpacity(1);
		chartOptions.getMarkers().setSize(0);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		
		Series series = new Series();
		series.setDataAsArrayPairs(getData());
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
		
	/**
	 * 
	 * @return
	 */
	public Apexchart areaChartConfigure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("35%").setType(ChartType.AREA).setId("chart1")
			.getBrush().setTarget("chart" + chartid).setEnabled(true);
		
		chartOptions.getChart().getSelection().setEnabled(true)
			.getXaxis().setMin(new Date("19 Jun 2017").getTime()).setMax(new Date("14 Aug 2017").getTime());
		
		chartOptions.setColors(Arrays.asList(new Color("#008FFB")));
		
		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setOpacityFrom(0.91).setOpacityTo(0.1);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME).getTooltip().setEnabled(false);
		chartOptions.getYaxisSingle().setTickAmount(2);
		
		Series series = new Series();
		series.setDataAsArrayPairs(getData());
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}

	/**
	 * 
	 * @return
	 */
	private List<Pair> getData() {
		Long x = 1486771200000L;
		List<Pair> data = new ArrayList<Pair>();
		int min = 30;
		int max = 90;
		
		for (int i = 0; i < 185; i++) {
			data.add(new Pair(x, Math.floor(Math.random() * (max - min + 1)) + min));
			
			x += 86400000;
		}
		
		return data;
	}
	
	/**
	 * 
	 */
	public List<Apexchart> getCharts() {
		List<Apexchart> chartList = new ArrayList<Apexchart>();
		
		chartid++;
		chartList.add(lineChartConfigure());
		chartList.add(areaChartConfigure());
		
		return chartList;
	}
	
}