package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.apexcharts.xaxis.group.Groups;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColumnWithGroupLabel extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		
		chartOptions.getXaxis().setType(AxisType.CATEGORY)
			.getLabels().setFormatter(new Function("return \"Q\" + dayjs(val).quarter()", "val"));
		
	    chartOptions.getXaxis().getGroup().getStyle().setFontSize("10px").setFontWeight(700);
	    chartOptions.getXaxis().getGroup()
	    	.setGroups(Arrays.asList(new Groups().setTitle("2019").setCols(4), new Groups().setTitle("2020").setCols(4)));
		
	    chartOptions.getTitle().setText("Grouped Labels on the X-axis");
	    
	    chartOptions.getTooltip().getX()
	    	.setFormatter(new Function("return \"Q\" + dayjs(val).quarter() + \" \" + dayjs(val).format(\"YYYY\")", "val"));

		Series series = new Series();
		series.setName("sales");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("2019/01/01").setY(400),
				new Data().setX("2019/04/01").setY(430),
				new Data().setX("2019/07/01").setY(448),
				new Data().setX("2019/10/01").setY(470),
				new Data().setX("2020/01/01").setY(540),
				new Data().setX("2020/04/01").setY(580),
				new Data().setX("2020/07/01").setY(690),
				new Data().setX("2020/10/01").setY(690)
				));

		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}