package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.GradientType;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.apexcharts.constants.TickPlacement;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ColumnWithRotatedLabels extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(false).setColumnWidth("50%").setBorderRadius(10);

		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setWidth(2);

		chartOptions.getGrid().getRow().setColors(Arrays.asList(new Color("#fff"), new Color("#f2f2f2")));

		chartOptions.getXaxis()
			.setTickPlacement(TickPlacement.ON)
			.setCategoriesAsArrayString(Arrays.asList(
				"Apples", "Oranges", "Strawberries", "Pineapples", "Mangoes", "Bananas", "Blackberries", 
				"Pears", "Watermelons", "Cherries", "Pomegranates", "Tangerines", "Papayas"))
			.getLabels().setRotate(-45).setRotateAlways(true);

		chartOptions.getYaxisSingle().getTitle().setText("Servings");

		chartOptions.getFill().setType(FillType.GRADIENT).getGradient()
			.setShade(Shade.LIGHT).setType(GradientType.HORIZONTAL).setShadeIntensity(0.25)
			.setInverseColors(true).setOpacityFrom(0.85).setOpacityTo(0.85)
			.setStops(Arrays.asList(50, 0, 100));
		
		chartOptions.getAnnotations().getPointsSingle()
			.setX("Bananas").setSeriesIndex(0)
			.getLabel().setBorderColor(new Color("#775DD0")).setOffsetY(0).setText("Bananas are good")
				.getStyle().setColor(new Color("#fff")).setBackground(new Color("#775DD0"));
		
		Series series = new Series();
		series.setName("Servings");
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 41, 67, 22, 43, 21, 33, 45, 31, 87, 65, 35));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}