package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.tooltip.Y;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class DashedLine extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.LINE).getZoom().setEnabled(false);
		chartOptions.getDataLabels().setEnabled(false);
		
		chartOptions.getStroke()
			.setCurve(Curve.STRAIGHT)
			.setWidth(Arrays.asList(5, 7, 5))
			.setDashArray(Arrays.asList(0, 8, 5));
		
		chartOptions.getTitle().setText("Page Statistics").setAlign((HorizontalAlign.LEFT));
		chartOptions.getLegend().setTooltipHoverFormatter(
			new Function("return val + ' - ' + opts.w.globals.series[opts.seriesIndex][opts.dataPointIndex] + ''", "val", "opts"));
		
		chartOptions.getMarkers().setSize(0).getHover().setSizeOffset(6);
		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList("01 Jan", "02 Jan", "03 Jan", "04 Jan", "05 Jan", "06 Jan", "07 Jan", "08 Jan", "09 Jan", "10 Jan", "11 Jan", "12 Jan"));

		Y y = new Y();
		y.getTitle().setFormatter(new Function("return val + \" (mins)\"", "val"));
		chartOptions.getTooltip().getYAsArrayObject().add(y);
		
		y = new Y();
		y.getTitle().setFormatter(new Function("return val + \" per session\"", "val"));
		chartOptions.getTooltip().getYAsArrayObject().add(y);
		
		y = new Y();
		y.getTitle().setFormatter(new Function("return val", "val"));
		chartOptions.getTooltip().getYAsArrayObject().add(y);
		
		chartOptions.getGrid().setBorderColor(new Color("#f1f1f1"));
				
		Series series = new Series();
		series.setName("Session Duration");
		series.setDataAsArrayNumber(Arrays.asList(45, 52, 38, 24, 33, 26, 21, 20, 6, 8, 15, 10));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Page Views");
		series.setDataAsArrayNumber(Arrays.asList(35, 41, 62, 42, 13, 18, 29, 37, 36, 51, 32, 35));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Total Visits");
		series.setDataAsArrayNumber(Arrays.asList(87, 57, 74, 99, 75, 38, 62, 47, 82, 56, 45, 47));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}