package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.GradientType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.constants.TickPlacement;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class DumbellChart extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RANGEBAR).getZoom().setEnabled(false);
		
		chartOptions.getPlotOptions().getBar()
			.setIsDumbbell(true).setColumnWidth(3)
			.setDumbbellColors(Arrays.asList(new Pair(new Color("#008FFB"), new Color("#00E396"))));
		
		chartOptions.getLegend().setShow(true).setShowForSingleSeries(true)
			.setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT)
			.setCustomLegendItems(Arrays.asList("Product A", "Product B"));
		
		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setType(GradientType.VERTICAL).setGradientToColors(Arrays.asList(new Color("#00E396")))
				.setInverseColors(true).setStops(Arrays.asList(0, 100));
		
		chartOptions.getGrid().getXaxis().getLines().setShow(true);
		chartOptions.getGrid().getYaxis().getLines().setShow(false);

		chartOptions.getXaxis().setTickPlacement(TickPlacement.ON);
		
		Series series = new Series();
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("2008").setY(Arrays.asList(2800, 4500)),
			new Data().setX("2009").setY(Arrays.asList(3200, 4100)),
			new Data().setX("2010").setY(Arrays.asList(2950, 7800)),
			new Data().setX("2011").setY(Arrays.asList(3000, 4600)),
			new Data().setX("2012").setY(Arrays.asList(3500, 4100)),
			new Data().setX("2013").setY(Arrays.asList(4500, 6500)),
			new Data().setX("2014").setY(Arrays.asList(4100, 5600))
			));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}