package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class DumbellChartHorizontal extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RANGEBAR).getZoom().setEnabled(false);
		
		chartOptions.setColors(Arrays.asList(new Color("#EC7D31"), new Color("#36BDCB")));
		
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(true)
			.setIsDumbbell(true)
			.setDumbbellColors(Arrays.asList(new Pair(new Color("#EC7D31"), new Color("#36BDCB"))));
		
		chartOptions.getTitle().setText("Paygap Disparity");

		chartOptions.getLegend().setShow(true).setShowForSingleSeries(true)
			.setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT)
			.setCustomLegendItems(Arrays.asList("Female", "Male"));

		chartOptions.getFill().setType(FillType.GRADIENT)
			.getGradient().setGradientToColors(Arrays.asList(new Color("#36BDCB")))
				.setInverseColors(true).setStops(Arrays.asList(0, 100));

		chartOptions.getGrid().getXaxis().getLines().setShow(true);
		chartOptions.getGrid().getYaxis().getLines().setShow(false);
		
		Series series = new Series();
		series.setDataAsArrayObject(Arrays.asList(
			new Data().setX("Operations").setY(Arrays.asList(2800, 4500)),
			new Data().setX("Customer Success").setY(Arrays.asList(3200, 4100)),
			new Data().setX("Engineering").setY(Arrays.asList(2950, 7800)),
			new Data().setX("Marketing").setY(Arrays.asList(3000, 4600)),
			new Data().setX("Product").setY(Arrays.asList(3500, 4100)),
			new Data().setX("Data Science").setY(Arrays.asList(4500, 6500)),
			new Data().setX("Sales").setY(Arrays.asList(4100, 5600))
			));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}