package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.FillType;
import com.hyjavaapex.model.apexcharts.constants.GradientType;
import com.hyjavaapex.model.apexcharts.constants.LineCap;
import com.hyjavaapex.model.apexcharts.constants.Position;
import com.hyjavaapex.model.apexcharts.constants.Shade;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class GradientRadial extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RADIALBAR).getToolbar().setShow(true);
		
		chartOptions.getPlotOptions().getRadialBar().setStartAngle(-135).setEndAngle(225)
			.getHollow().setMargin(0).setSize("70%").setBackground(new Color("#fff"))
				.setImageOffsetX(0).setImageOffsetY(0).setPosition(Position.FRONT)
				.getDropShadow().setEnabled(true).setTop(3).setLeft(0).setBlur(4).setOpacity(0.24);
		
		chartOptions.getPlotOptions().getRadialBar().getTrack()
			.setBackground(new Color("#fff")).setStrokeWidth("67%").setMargin(0)
			.getDropShadow().setEnabled(true).setTop(-3).setLeft(0).setBlur(4).setOpacity(0.35);
		
		chartOptions.getPlotOptions().getRadialBar().getDataLabels()
			.setShow(true).getName().setOffsetY(-10).setShow(true)
			.setColor(new Color("#888")).setFontSize("17px");
		
		chartOptions.getPlotOptions().getRadialBar().getDataLabels().getValue()
			.setFormatter(new Function("return parseInt(val);", "val"))
			.setColor(new Color("#111")).setFontSize("36px").setShow(true);
		
		chartOptions.getFill().setType(FillType.GRADIENT)
        	.getGradient().setShade(Shade.DARK).setType(GradientType.HORIZONTAL)
        	.setShadeIntensity(0.5).setGradientToColors(Arrays.asList(new Color("#ABE5A1")))
        	.setInverseColors(true).setOpacityFrom(1).setOpacityTo(1)
        	.setStops(Arrays.asList(0, 100));
			
		chartOptions.getStroke().setLineCap(LineCap.ROUND);

		chartOptions.setLabels(Arrays.asList("Percent"));
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(75));
		
		return apexchart;
	}
	
}
