package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MissingNullValues extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.LINE).getZoom().setEnabled(false);
		chartOptions.getChart().getAnimations().setEnabled(false);

		chartOptions.getStroke().setWidth(Arrays.asList(5,5,4)).setCurve(Curve.STRAIGHT);
		
		chartOptions.getTitle().setText("Missing data (null values)");
		chartOptions.setLabels(Arrays.asList("1", "2", "3", "4", "5", "6", "7", "8", 
											 "9", "10", "11", "12", "13", "14", "15", "16"));
		
		Series series = new Series();
		series.setName("Peter");
		series.setDataAsArrayNumber(Arrays.asList(5, 5, 10, 8, 7, 5, 4, null, null, null, 10, 10, 7, 8, 6, 9));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Johnny");
		series.setDataAsArrayNumber(Arrays.asList(10, 15, null, 12, null, 10, 12, 15, null, null, 12, null, 14, null, null, null));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("David");
		series.setDataAsArrayNumber(Arrays.asList(null, null, null, null, 3, 4, 1, 3, 4,  6,  7,  9, 5, null, null, null));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}
