package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class Pyramid extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		chartOptions.getPlotOptions().getBar()
			.setHorizontal(true).setDistributed(true).setBorderRadius(0).setBarHeight("80%").setIsFunnel(true);
		
		chartOptions.getDataLabels().setEnabled(true)
			.setFormatter(new Function("return opt.w.globals.labels[opt.dataPointIndex]", "val", "opt"));
		chartOptions.getDataLabels().getDropShadow().setEnabled(true);

		chartOptions.getTitle().setText("Pyramid Chart").setAlign(HorizontalAlign.CENTER);

		chartOptions.getXaxis().setCategoriesAsArrayString(Arrays.asList(
			"Sweets", "Processed Foods", "Healthy Fats", "Meat", 
			"Beans & Legumes", "Dairy", "Fruits & Vegetables", "Grains"));

 		chartOptions.setColors(Arrays.asList(
				new Color("#F44F5E"), new Color("#E55A89"), new Color("#D863B1"), new Color("#CA6CD8"), 
				new Color("#B57BED"), new Color("#8D95EB"), new Color("#62ACEA"), new Color("#4BC3E6")));
		
		chartOptions.getLegend().setShow(false);
		
		Series series = new Series();
		series.setName("").setDataAsArrayNumber(Arrays.asList(200, 330, 548, 740, 880, 990, 1100, 1380));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}