package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.constants.StackType;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class StackedBars100 extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR)
			.setStacked(true).setStackType(StackType.PERCENT100);
		
		chartOptions.getTitle().setText("100% Stacked Bar");
		chartOptions.getPlotOptions().getBar().setHorizontal(true);
		chartOptions.getStroke().setWidth(1).getColors().add(new Color("#fff"));
		
		chartOptions.getXaxis()
		.setCategoriesAsArrayNumber(Arrays.asList(2008, 2009, 2010, 2011, 2012, 2013, 2014));

		chartOptions.getTooltip().getY().setFormatter(new Function("return val + \"K\"", "val"));
		chartOptions.getFill().setOpacity(1);
		chartOptions.getLegend()
			.setPosition(LegendPosition.TOP).setHorizontalAlign(HorizontalAlign.LEFT).setOffsetX(40);
		
		Series series = new Series();
		series.setName("Marine Sprite").setDataAsArrayNumber(Arrays.asList(44, 55, 41, 37, 22, 43, 21));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Striking Calf").setDataAsArrayNumber(Arrays.asList(53, 32, 33, 52, 13, 43, 32));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Tank Picture").setDataAsArrayNumber(Arrays.asList(12, 17, 11, 9, 15, 11, 20));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Bucket Slope").setDataAsArrayNumber(Arrays.asList(9, 7, 5, 8, 6, 9, 4));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Reborn Kid").setDataAsArrayNumber(Arrays.asList(25, 12, 19, 32, 25, 24, 10));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}