package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.apexcharts.constants.StackType;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class StackedColumn100 extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR)
			.setStacked(true).setStackType(StackType.PERCENT100);

		chartOptions.getResponsiveSingle().setBreakpoint(480)
			.getOptions().getLegend().setPosition(LegendPosition.BOTTOM).setOffsetX(-10).setOffsetY(0);

		chartOptions.getXaxis().setCategoriesAsArrayString(Arrays.asList(
			"2011 Q1", "2011 Q2", "2011 Q3", "2011 Q4", "2012 Q1", "2012 Q2", "2012 Q3", "2012 Q4"));

		chartOptions.getLegend().setPosition(LegendPosition.RIGHT).setOffsetX(0).setOffsetY(50);
		chartOptions.getFill().setOpacity(1);
		
		Series series = new Series();
		series.setName("PRODUCT A");
		series.setDataAsArrayNumber(Arrays.asList(44, 55, 41, 67, 22, 43, 21, 49));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT B");
		series.setDataAsArrayNumber(Arrays.asList(13, 23, 20, 8, 13, 27, 33, 12));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("PRODUCT C");
		series.setDataAsArrayNumber(Arrays.asList(11, 17, 15, 15, 21, 14, 15, 13));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}