package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.AxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicArea extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.AREA).getZoom().setEnabled(false);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setCurve(Curve.STRAIGHT);
		
		chartOptions.getTitle().setText("Fundamental Analysis of Stocks").setAlign(HorizontalAlign.LEFT);
		chartOptions.getSubtitle().setText("Price Movements").setAlign(HorizontalAlign.LEFT);
		
		chartOptions.getXaxis().setType(AxisType.DATETIME);
		chartOptions.getYaxisSingle().setOpposite(true);
		chartOptions.getLegend().setHorizontalAlign(HorizontalAlign.LEFT);
		
		chartOptions.setLabels(Arrays.asList(
			"13 Nov 2017", "14 Nov 2017", "15 Nov 2017", "16 Nov 2017", "17 Nov 2017", "20 Nov 2017", 
			"21 Nov 2017", "22 Nov 2017", "23 Nov 2017", "24 Nov 2017", "27 Nov 2017", "28 Nov 2017", 
			"29 Nov 2017", "30 Nov 2017", "01 Dec 2017", "04 Dec 2017", "05 Dec 2017", "06 Dec 2017", 
			"07 Dec 2017", "08 Dec 2017"));
		
		Series series = new Series();
		series.setName("STOCK ABC");
		series.setDataAsArrayNumber(Arrays.asList(
			8107.85, 8128.0, 8122.9, 8165.5, 8340.7, 8423.7, 8423.5, 8514.3, 8481.85, 8487.7, 8506.9, 
			8626.2, 8668.95, 8602.3, 8607.55, 8512.9, 8496.25, 8600.65, 8881.1, 9340.85));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}