package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicHeatmap extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.HEATMAP);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.setColors(Arrays.asList(new Color("#008FFB")));
		chartOptions.getTitle().setText("HeatMap Chart (Single color)");

		chartOptions.getSeries().add(getData().setName("Metric1"));
		chartOptions.getSeries().add(getData().setName("Metric2"));
		chartOptions.getSeries().add(getData().setName("Metric3"));
		chartOptions.getSeries().add(getData().setName("Metric4"));
		chartOptions.getSeries().add(getData().setName("Metric5"));
		chartOptions.getSeries().add(getData().setName("Metric6"));
		chartOptions.getSeries().add(getData().setName("Metric7"));
		chartOptions.getSeries().add(getData().setName("Metric8"));
		chartOptions.getSeries().add(getData().setName("Metric9"));

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private Series getData() {
		int countMax = 18;
		int yRangeMin = 0;
		int yRangeMax = 90;
		
		Series series = new Series();
		List<Data> data = new ArrayList<Data>();
		
		for (int i = 0; i < countMax; i++) {
			data.add(new Data()
				.setX("w" + (i + 1))
				.setY(Math.floor(Math.random() * (yRangeMax - yRangeMin + 1)) + yRangeMin));
		}
		
		series.setDataAsArrayObject(data);
		
		return series;
	}
	
}
