package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicRangeArea extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RANGEAREA);
		chartOptions.getStroke().setCurve(Curve.STRAIGHT);
		chartOptions.getTitle().setText("New York Temperature (all year round)");
		chartOptions.getMarkers().getHover().setSizeOffset(5);
		chartOptions.getDataLabels().setEnabled(false);

		chartOptions.getYaxisSingle().getLabels().setFormatter(new Function("return val + '°C'", "val"));
		
		Series series = new Series();
		series.setName("New York Temperature");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan").setY(Arrays.asList(-2, 4)),
				new Data().setX("Feb").setY(Arrays.asList(-1, 6)),
				new Data().setX("Mar").setY(Arrays.asList(3, 10)),
				new Data().setX("Apr").setY(Arrays.asList(8, 16)),
				new Data().setX("May").setY(Arrays.asList(13, 22)),
				new Data().setX("Jun").setY(Arrays.asList(18, 26)),
				new Data().setX("Jul").setY(Arrays.asList(21, 29)),
				new Data().setX("Aug").setY(Arrays.asList(21, 28)),
				new Data().setX("Sep").setY(Arrays.asList(17, 24)),
				new Data().setX("Oct").setY(Arrays.asList(11, 18)),
				new Data().setX("Nov").setY(Arrays.asList(6, 12)),
				new Data().setX("Dec").setY(Arrays.asList(1, 7))
						));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}