package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;
import java.util.List;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartAxisType;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.common.Function;
import com.hyjavaapex.model.common.Pair;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class BasicScatter extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.SCATTER)
			.getZoom().setEnabled(true).setType(ChartAxisType.XY);
		
		chartOptions.getXaxis().setTickAmount(10)
			.getLabels().setFormatter(new Function("return parseFloat(val).toFixed(1);", "val"));
		chartOptions.getYaxisSingle().setTickAmount(7);

		chartOptions.getSeries().add(new Series()
			.setName("SAMPLE A").setDataAsArrayPairs(getData(1)));
		chartOptions.getSeries().add(new Series()
			.setName("SAMPLE B").setDataAsArrayPairs(getData(2)));
		chartOptions.getSeries().add(new Series()
			.setName("SAMPLE C").setDataAsArrayPairs(getData(3)));

		return apexchart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Pair> getData(int sample) {
		if (sample == 1) {
			return Arrays.asList(new Pair(16.4, 5.4), new Pair(21.7, 2), new Pair(25.4, 3), new Pair(19, 2), new Pair(10.9, 1), new Pair(13.6, 3.2), new Pair(10.9, 7.4), new Pair(10.9, 0), new Pair(10.9, 8.2), new Pair(16.4, 0), new Pair(16.4, 1.8), new Pair(13.6, 0.3), new Pair(13.6, 0), new Pair(29.9, 0), new Pair(27.1, 2.3), new Pair(16.4, 0), new Pair(13.6, 3.7), new Pair(10.9, 5.2), new Pair(16.4, 6.5), new Pair(10.9, 0), new Pair(24.5, 7.1), new Pair(10.9, 0), new Pair(8.1, 4.7), new Pair(19, 0), new Pair(21.7, 1.8), new Pair(27.1, 0), new Pair(24.5, 0), new Pair(27.1, 0), new Pair(29.9, 1.5), new Pair(27.1, 0.8), new Pair(22.1, 2));
		}
		else if (sample == 2) {
			return Arrays.asList(new Pair(36.4, 13.4), new Pair(1.7, 11), new Pair(5.4, 8), new Pair(9, 17), new Pair(1.9, 4), new Pair(3.6, 12.2), new Pair(1.9, 14.4), new Pair(1.9, 9), new Pair(1.9, 13.2), new Pair(1.4, 7), new Pair(6.4, 8.8), new Pair(3.6, 4.3), new Pair(1.6, 10), new Pair(9.9, 2), new Pair(7.1, 15), new Pair(1.4, 0), new Pair(3.6, 13.7), new Pair(1.9, 15.2), new Pair(6.4, 16.5), new Pair(0.9, 10), new Pair(4.5, 17.1), new Pair(10.9, 10), new Pair(0.1, 14.7), new Pair(9, 10), new Pair(12.7, 11.8), new Pair(2.1, 10), new Pair(2.5, 10), new Pair(27.1, 10), new Pair(2.9, 11.5), new Pair(7.1, 10.8), new Pair(2.1, 12));
		}
		else {
			return Arrays.asList(new Pair(21.7, 3), new Pair(23.6, 3.5), new Pair(24.6, 3), new Pair(29.9, 3), new Pair(21.7, 20), new Pair(23, 2), new Pair(10.9, 3), new Pair(28, 4), new Pair(27.1, 0.3), new Pair(16.4, 4), new Pair(13.6, 0), new Pair(19, 5), new Pair(22.4, 3), new Pair(24.5, 3), new Pair(32.6, 3), new Pair(27.1, 4), new Pair(29.6, 6), new Pair(31.6, 8), new Pair(21.6, 5), new Pair(20.9, 4), new Pair(22.4, 0), new Pair(32.6, 10.3), new Pair(29.7, 20.8), new Pair(24.5, 0.8), new Pair(21.4, 0), new Pair(21.7, 6.9), new Pair(28.6, 7.7), new Pair(15.4, 0), new Pair(18.1, 0), new Pair(33.4, 0), new Pair(16.4, 0));
		}
	}
	
}
