package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.Curve;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.series.Data;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class ComboRangeArea extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RANGEAREA).getAnimations().setSpeed(500);
		chartOptions.setColors(Arrays.asList(new Color("#d4526e"), new Color("#33b2df"), 
											 new Color("#d4526e"), new Color("#33b2df")));
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getFill().setOpacity(Arrays.asList(0.24, 0.24, 1, 1));
		chartOptions.getForecastDataPoints().setCount(2);
		chartOptions.getStroke().setCurve(Curve.STRAIGHT).setWidth(Arrays.asList(0, 0, 2, 2));
		chartOptions.getLegend().setShow(true).setInverseOrder(true)
								.setCustomLegendItems(Arrays.asList("Team B", "Team A"));
		chartOptions.getTitle().setText("Range Area with Forecast Line (Combo)");
		chartOptions.getMarkers().getHover().setSizeOffset(5);

		Series series = new Series();
		series.setType(SeriesType.RANGEAREA).setName("Team B Range");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan").setY(Arrays.asList(1100, 1900)),
				new Data().setX("Feb").setY(Arrays.asList(1200, 1800)),
				new Data().setX("Mar").setY(Arrays.asList(900, 2900)),
				new Data().setX("Apr").setY(Arrays.asList(1400, 2700)),
				new Data().setX("May").setY(Arrays.asList(2600, 3900)),
				new Data().setX("Jun").setY(Arrays.asList(500, 1700)),
				new Data().setX("Jul").setY(Arrays.asList(1900, 2300)),
				new Data().setX("Aug").setY(Arrays.asList(1000, 1500))
						));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setType(SeriesType.RANGEAREA).setName("Team A Range");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan").setY(Arrays.asList(3100, 3400)),
				new Data().setX("Feb").setY(Arrays.asList(4200, 5200)),
				new Data().setX("Mar").setY(Arrays.asList(3900, 4900)),
				new Data().setX("Apr").setY(Arrays.asList(3400, 3900)),
				new Data().setX("May").setY(Arrays.asList(5100, 5900)),
				new Data().setX("Jun").setY(Arrays.asList(5400, 6700)),
				new Data().setX("Jul").setY(Arrays.asList(4300, 4600)),
				new Data().setX("Aug").setY(Arrays.asList(2100, 2900))
						));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setType(SeriesType.LINE).setName("Team B Median");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan").setY(1500),
				new Data().setX("Feb").setY(1700),
				new Data().setX("Mar").setY(1900),
				new Data().setX("Apr").setY(2200),
				new Data().setX("May").setY(3000),
				new Data().setX("Jun").setY(1000),
				new Data().setX("Jul").setY(2100),
				new Data().setX("Aug").setY(1200),
				new Data().setX("Sep").setY(1800),
				new Data().setX("Oct").setY(2000)
						));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setType(SeriesType.LINE).setName("Team A Median");
		series.setDataAsArrayObject(Arrays.asList(
				new Data().setX("Jan").setY(3300),
				new Data().setX("Feb").setY(4900),
				new Data().setX("Mar").setY(4300),
				new Data().setX("Apr").setY(3700),
				new Data().setX("May").setY(5500),
				new Data().setX("Jun").setY(5900),
				new Data().setX("Jul").setY(4500),
				new Data().setX("Aug").setY(2400),
				new Data().setX("Sep").setY(2100),
				new Data().setX("Oct").setY(1500)
						));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}