package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.LegendPosition;
import com.hyjavaapex.model.common.Color;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class CustomAngleCircle extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.RADIALBAR);
		
		chartOptions.getPlotOptions().getRadialBar()
			.setOffsetY(0).setStartAngle(0).setEndAngle(270)
			.getHollow().setMargin(5).setSize("30%").setBackground(new Color("transparent"));
		chartOptions.getPlotOptions().getRadialBar().getDataLabels().getName().setShow(false);
		chartOptions.getPlotOptions().getRadialBar().getDataLabels().getValue().setShow(false);

		chartOptions.setColors(Arrays.asList(
			new Color("#1ab7ea"), new Color("#0084ff"), new Color("#39539E"), new Color("#0077B5")));
		
		chartOptions.getLegend()
			.setShow(true).setFloating(true).setFontSize("16px").setPosition(LegendPosition.LEFT)
			.setOffsetX(160).setOffsetY(15).getLabels().setUseSeriesColors(true);
		chartOptions.getLegend().setFormatter(
			new Function("return seriesName + \":  \" + opts.w.globals.series[opts.seriesIndex]", "seriesName", "opts"))
			.getItemMargin().setVertical(3);
		
		chartOptions.getMarkers().setSize(0);
		
		chartOptions.getResponsiveSingle().setBreakpoint(480).getOptions().getLegend().setShow(false);

		chartOptions.setLabels(Arrays.asList("Vimeo", "Messenger", "Facebook", "LinkedIn"));
		chartOptions.setSeriesAsArrayNumber(Arrays.asList(76, 67, 61, 90));
		
		return apexchart;
	}
	
}