package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.common.Function;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class Funnel extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.BAR);
		chartOptions.getPlotOptions().getBar().setHorizontal(true).setBorderRadius(0).setBarHeight("80%").setIsFunnel(true);
		
		chartOptions.getDataLabels().setEnabled(true)
			.setFormatter(new Function("return opt.w.globals.labels[opt.dataPointIndex] + ':  ' + val", "val", "opt"));
		chartOptions.getDataLabels().getDropShadow().setEnabled(true);

		chartOptions.getTitle().setText("Recruitment Funnel").setAlign(HorizontalAlign.CENTER);

		chartOptions.getXaxis()
			.setCategoriesAsArrayString(Arrays.asList(
					"Sourced", "Screened", "Assessed", "HR Interview", "Technical", "Verify", "Offered", "Hired"));
		
		chartOptions.getLegend().setShow(false);
		
		Series series = new Series();
		series.setName("Funnel Series").setDataAsArrayNumber(Arrays.asList(1380, 1100, 990, 880, 740, 548, 330, 200));
		chartOptions.getSeries().add(series);

		return apexchart;
	}
	
}