package com.webonlineapp.hyjavaapexdemo.examplecharts;

import java.util.Arrays;

import com.hyjavaapex.chart.Apexchart;
import com.hyjavaapex.model.apexcharts.ChartOptions;
import com.hyjavaapex.model.apexcharts.Series;
import com.hyjavaapex.model.apexcharts.Yaxis;
import com.hyjavaapex.model.apexcharts.constants.ChartType;
import com.hyjavaapex.model.apexcharts.constants.HorizontalAlign;
import com.hyjavaapex.model.apexcharts.constants.SeriesType;
import com.hyjavaapex.model.apexcharts.constants.TooltipPosition;
import com.hyjavaapex.model.common.Color;
import com.webonlineapp.hyjavaapexdemo.charts.DemoChartBase;

public class MultipleYAxis extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Apexchart configure() {
		Apexchart apexchart = new Apexchart();
		ChartOptions chartOptions = apexchart.getChartOptions();
		
		chartOptions.getChart().setHeight("100%").setType(ChartType.LINE).setStacked(false);
		chartOptions.getDataLabels().setEnabled(false);
		chartOptions.getStroke().setWidth(Arrays.asList(1, 1, 4));
		
		chartOptions.getTitle().setText("XYZ - Stock Analysis (2009 - 2016)")
			.setAlign(HorizontalAlign.LEFT).setOffsetX(110);

		chartOptions.setLabels(Arrays.asList(
				"2009", "2010", "2011", "2012", "2013", "2014", "2015", "2016"));

		Yaxis yaxis = new Yaxis();
		yaxis.getAxisTicks().setShow(true);
		yaxis.getAxisBorder().setShow(true).setColor(new Color("#008FFB"));
		yaxis.getLabels().getStyle().setColors(new Color("#008FFB"));
		yaxis.getTitle().setText("Income (thousand crores)").getStyle().setColor(new Color("#008FFB"));
		yaxis.getTooltip().setEnabled(true);
		chartOptions.getYaxis().add(yaxis);
		
		yaxis = new Yaxis();
		yaxis.setSeriesName("Income").setOpposite(true).getAxisTicks().setShow(true);
		yaxis.getAxisBorder().setShow(true).setColor(new Color("#00E396"));
		yaxis.getLabels().getStyle().setColors(new Color("#00E396"));
		yaxis.getTitle().setText("Operating Cashflow (thousand crores)").getStyle().setColor(new Color("#00E396"));
		chartOptions.getYaxis().add(yaxis);
		
		yaxis = new Yaxis();
		yaxis.setSeriesName("Revenue").setOpposite(true).getAxisTicks().setShow(true);
		yaxis.getAxisBorder().setShow(true).setColor(new Color("#FEB019"));
		yaxis.getLabels().getStyle().setColors(new Color("#FEB019"));
		yaxis.getTitle().setText("Revenue (thousand crores)").getStyle().setColor(new Color("#FEB019"));
		chartOptions.getYaxis().add(yaxis);
		
		chartOptions.getTooltip().getFixed().setEnabled(true)
			.setPosition(TooltipPosition.TOPLEFT).setOffsetY(30).setOffsetX(80);
		
		chartOptions.getLegend().setHorizontalAlign(HorizontalAlign.LEFT).setOffsetX(40);
		
		Series series = new Series();
		series.setName("Income").setType(SeriesType.COLUMN);
		series.setDataAsArrayNumber(Arrays.asList(1.4, 2, 2.5, 1.5, 2.5, 2.8, 3.8, 4.6));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Cashflow").setType(SeriesType.COLUMN);
		series.setDataAsArrayNumber(Arrays.asList(1.1, 3, 3.1, 4, 4.1, 4.9, 6.5, 8.5));
		chartOptions.getSeries().add(series);
		
		series = new Series();
		series.setName("Revenue").setType(SeriesType.LINE);
		series.setDataAsArrayNumber(Arrays.asList(20, 29, 37, 36, 44, 45, 50, 58));
		chartOptions.getSeries().add(series);
		
		return apexchart;
	}
	
}