package com.webonlineapp.hyjavachartsdemo11.charts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.webonlineapp.hyjavachartsdemo11.examplecharts.*;

public class DemoCharts {

	private static final List<DemoChart> demoChartsList = new ArrayList<DemoChart>(Arrays.asList(
		// Line Charts
		new DemoChart("Line Charts"),
    	new DemoChart("Line Chart", new LineChart()),
    	new DemoChart("With Data Labels", new WithDataLabels()),
    	new DemoChart("Spline With Symbols", new SplineWithSymbols()),
    	new DemoChart("Spline With Inverted Axis", new SplineWithInvertedAxis()),
    	new DemoChart("Logarithmic Axis", new LogarithmicAxis()),
    	new DemoChart("Line Points", new LinePoints()),
    	new DemoChart("With Annotations", new WithAnnotations()),
    	new DemoChart("Line Chart With 500k Points", new LineChartWith500kPoints()),
    	new DemoChart("Time Series Zoomable", new TimeSeriesZoomable()),
    	new DemoChart("Spline With PlotBands", new SplineWithPlotBands()),
    	new DemoChart("Time Data Irregular Intervals", new TimeDataWithIrregularIntervals()),
    	new DemoChart("CPU Utilization", new CPUUtilization()),
    	new DemoChart("Line Graph", new LineGraph()),
    	new DemoChart("Line With Zones", new LineWithZones()),
    	
    	// Area Charts
    	new DemoChart("Area Charts"),
    	new DemoChart("Basic Area", new BasicArea()),
    	new DemoChart("Percentage Area", new PercentageArea()),
    	new DemoChart("Stacked Area", new StackedArea()),
    	new DemoChart("Area Range", new AreaRange()),
    	new DemoChart("Area Spline", new AreaSpline()),
    	new DemoChart("Inverted Axis", new InvertedAxis()),
    	new DemoChart("Area With Negative Values", new AreaWithNegativeValues()),
    	new DemoChart("Area Range And Line", new AreaRangeAndLine()),
    	new DemoChart("Fan Chart", new FanChart()),
    	new DemoChart("Stacked Inverted Area", new StackedInvertedArea()),
    	new DemoChart("Area With Missing Points", new AreaWithMissingPoints()),
    	
    	// Column and Bar Charts
    	new DemoChart("Column and Bar Charts"),
    	new DemoChart("Basic Bar", new BasicBar()),
    	new DemoChart("Basic Column", new BasicColumn()),
    	new DemoChart("Stacked And Grouped Column", new StackedAndGroupedColumn()),
    	new DemoChart("Column Range", new ColumnRange()),
    	new DemoChart("Variwide", new VariWide()),
    	new DemoChart("Column With Negative Values", new ColumnWithNegativeValues()),
    	new DemoChart("Column With Drilldown", new ColumnWithDrilldown()),
    	new DemoChart("Fixed Placement Columns", new FixedPlacementColumns()),
    	new DemoChart("Column With Rotated Labels", new ColumnWithRotatedLabels()),
    	new DemoChart("Column Comparison", new ColumnComparison()),
    	new DemoChart("Stacked Column", new StackedColumn()),
    	new DemoChart("Radial Bar", new RadialBar()),
    	new DemoChart("Stacked Bar", new StackedBar()),
    	new DemoChart("Stacked Percentage Column", new StackedPercentageColumn()),
    	new DemoChart("Bar With Negative Stack", new BarWithNegativeStack()),
    	new DemoChart("Breadcrumbs Single Button", new BreadcrumbsSingleButton()),
    	new DemoChart("Column With Caption", new ColumnWithCaption()),
    	new DemoChart("Bar Comparison", new BarComparison()),
    	
    	// Pie Charts
    	new DemoChart("Pie Charts"),
    	new DemoChart("Pie Chart", new PieChart()),
    	new DemoChart("Donut Chart Race", new DonutChartRace()),
    	new DemoChart("Donut Chart", new DonutChart()),
    	new DemoChart("Pie With Monochrome Fill", new PieWithMonochromeFill()),
    	new DemoChart("Pie With Drilldown", new PieWithDrilldown()),
    	new DemoChart("Pie With Legend", new PieWithLegend()),
    	new DemoChart("Pie With Gradient Fill", new PieWithGradientFill()),
    	new DemoChart("Variable Radius Pie", new VariableRadiusPie()),
    	new DemoChart("Semi Circle Donut", new SemiCircleDonut()),
    	new DemoChart("Air Composition Donut", new AirCompositionDonut()),

    	// Scatter and Bubble Charts
    	new DemoChart("Scatter and Bubble Charts"),
    	new DemoChart("Bubble Chart", new BubbleChart()),
    	new DemoChart("Scatter Plot", new ScatterPlot()),
    	new DemoChart("Scatter Plot With Jitter", new ScatterPlotWithJitter()),
    	new DemoChart("Packed Bubble Chart", new PackedBubbleChart(), ChartDisplay.STANDARD_JS),
    	new DemoChart("Packed Bubble Chart", new PackedBubbleChartES(), ChartDisplay.IMAGE_JS),
    	new DemoChart("Split Packed Bubble Chart", new SplitPackedBubbleChart(), ChartDisplay.STANDARD_JS),
    	new DemoChart("Split Packed Bubble Chart", new SplitPackedBubbleChartES(), ChartDisplay.IMAGE_JS),
    	new DemoChart("3D Bubbles", new ThreeDBubbles()),
    	new DemoChart("Scatter Plot With 1 Million Points", new ScatterPlotWith1MPoints()),
    	new DemoChart("Bubble With Color Axis", new BubbleWithColorAxis()),
    	new DemoChart("Packed Bubble With Color Axis", new PackedBubbleWithColorAxis(), ChartDisplay.STANDARD_JS),
    	new DemoChart("Packed Bubble With Color Axis", new PackedBubbleWithColorAxisES(), ChartDisplay.IMAGE_JS),
 
    	// Combinations
    	new DemoChart("Combinations"),
    	new DemoChart("Multiple Axis", new MultipleAxis()),
    	new DemoChart("Dual Axis Line And Column", new DualAxisLineAndColumn()),
    	new DemoChart("Scatter With Trend Line", new ScatterWithTrendLine()),
    	new DemoChart("Column Line And Pie", new ColumnLineAndPie()),
   	
    	// Accessible charts
    	new DemoChart("Accessible charts"),
    	new DemoChart("Line Styles", new LineStyles()),
    	new DemoChart("Pie With Patterns", new PieWithPatterns()),
    	new DemoChart("Pattern Fill Pie", new PatternFillPieChart()),
    	new DemoChart("Pattern Fill Area", new PatternFillAreaChart()),
    	
    	// Audio charts
    	new DemoChart("Audio charts").setNewChart(),
    	new DemoChart("Basic Context Cues", new BasicContextCues()),
    	new DemoChart("Audio Boxplot", new AudioBoxplot()),
    	new DemoChart("Instrument", new Instrument()),
    	new DemoChart("Sonified Function", new SonifiedFunction()),
     	
    	new DemoChart("In Sequence", new InSequence()),
    	new DemoChart("Simultaneously", new Simultaneously()),
    	new DemoChart("Mapping Pitch to Data", new MappingPitchtoData()),
    	new DemoChart("Logarithmic Pitch Mapping", new LogarithmicPitchMapping()),
    	new DemoChart("Musical Scales", new MusicalScales()),
    	new DemoChart("Time Mapping", new TimeMapping()),
    	new DemoChart("Custom Instrument", new CustomInstrument()),
    	new DemoChart("Speech Mapping", new SpeechMapping()),
    	new DemoChart("Conditional Tracks", new ConditionalTracks()),
    	new DemoChart("Notifications", new Notifications()),
     	
    	// Dynamic Charts
    	new DemoChart("Dynamic Charts"),
    	new DemoChart("Click To Add A Point", new ClickToAddAPoint()),
    	new DemoChart("Live Data From Dynamic CSV", new LiveDataFromDynamicCSV()),
    	new DemoChart("Spline Updating Each Second", new SplineUpdatingEachSecond()),
    	new DemoChart("Server Monitoring", new ServerMonitoring()),
    	
    	// 3D Charts
    	new DemoChart("3D Charts"),
    	new DemoChart("3D Column With Stacking", new ThreeDColumnWithStacking()),
    	new DemoChart("3D Donut", new ThreeDDonut()),
    	new DemoChart("3D Area Chart", new ThreeDArea()),
    	new DemoChart("3D Funnel", new ThreeDFunnelChart()),
    	new DemoChart("3D Pyramid", new ThreeDPyramidChart()),
    	new DemoChart("3D Column With Null And Zeros", new ThreeDColumnWithNullAndZeros()),
    	new DemoChart("3D Column", new ThreeDColumn()),
    	new DemoChart("3D Scatter Chart", new ThreeDScatterChart()),
    	new DemoChart("3D Pie", new ThreeDPie()),
    	new DemoChart("3D Cylinder", new ThreeDCylinderChart()),
    	
    	// Gauges
    	new DemoChart("Gauges"),
    	new DemoChart("Gauge Series", new GaugeSeries()),
    	new DemoChart("VU Meter", new VUMeter()),
    	new DemoChart("Bullet Graph", new BulletGraph()),
    	new DemoChart("Solid Gauge", new SolidGauge()),
    	new DemoChart("Gauge With Dual Axis", new GaugeWithDualAxis()),
    	new DemoChart("Gauge Dial Options", new GaugeDialOptions()),
    	new DemoChart("Gauge Series Dial", new GaugeSeriesDial()),
    	new DemoChart("Gauge", new Gauge()),

    	// Heat and Tree Maps
    	new DemoChart("Heat and Tree Maps"),
    	new DemoChart("Heat Map", new HeatMap()),
    	new DemoChart("Tree Map With Color Axis", new TreeMapWithColorAxis()),
    	new DemoChart("Tree Map With Levels", new TreeMapWithLevels()),
    	new DemoChart("Tile Map Honeycomb", new TileMapHoneycomb()),
    	new DemoChart("Large Heat Map", new LargeHeatMap()),
    	
    	// Heat and Tree Maps
    	new DemoChart("Trees and Networks"),
    	new DemoChart("Network Graph", new NetworkGraph(), ChartDisplay.STANDARD_JS),
    	new DemoChart("Network Graph", new NetworkGraphES(), ChartDisplay.IMAGE_JS),
    	new DemoChart("Network Graph Flights", new NetworkGraphFlights(), ChartDisplay.STANDARD_JS),
    	new DemoChart("Network Graph Flights", new NetworkGraphFlightsES(), ChartDisplay.IMAGE_JS),
    	
    	// More Chart Types
    	new DemoChart("More Chart Types"),
    	new DemoChart("Lollipop Series", new LollipopSeries()),
    	new DemoChart("Arc Diagram", new ArcDiagram()),
    	new DemoChart("Venn Diagram", new VennDiagram()),
    	new DemoChart("Polar Chart", new PolarChart()),
    	new DemoChart("Column Pyramid", new ColumnPyramid()),
    	new DemoChart("Pictorial Chart 1", new PictorialChart1()).setNewChart(),
    	new DemoChart("Waterfall", new Waterfall()),
    	new DemoChart("XRange Series", new XRangeSeries()),
    	new DemoChart("Pyramid Chart", new PyramidChart()),
    	new DemoChart("Vector Plot", new VectorPlot()),
    	new DemoChart("Organization Chart", new OrganizationChart()),
    	new DemoChart("Pictorial Chart 2", new PictorialChart2()).setNewChart(),
    	new DemoChart("Polygon Series", new PolygonSeries()),
    	new DemoChart("Pareto Chart", new ParetoChart()),
    	new DemoChart("Wind Barb", new WindBarb()),
    	new DemoChart("Treegraph chart", new TreegraphChart()).setNewChart(),
    	new DemoChart("Euler Diagram", new EulerDiagram()),
    	new DemoChart("Dependency Wheel", new DependencyWheel()),
    	new DemoChart("Box Plot", new BoxPlot()),
    	new DemoChart("Parallel Coordinates", new ParallelCoordinates()),
    	new DemoChart("Bell Curve", new BellCurve()),
    	new DemoChart("Lower/Upper Dumbbell Markers", new LowerAndUpperDumbbellMarkers()),
    	new DemoChart("Sankey Diagram", new SankeyDiagram()),
    	new DemoChart("Parliament Chart", new ParliamentChart()),
    	new DemoChart("Word Cloud", new WordCloud()),
    	new DemoChart("Spider Web", new SpiderWeb()),
    	new DemoChart("Wind Rose", new WindRose()),
    	new DemoChart("Inverted Treegraph", new InvertedTreegraph()).setNewChart(),
    	new DemoChart("Error Bar", new ErrorBar()),
    	new DemoChart("Treegraph Box Layout", new TreegraphBoxLayout()).setNewChart(),
    	new DemoChart("Timeline", new Timeline()),
    	new DemoChart("Sunburst", new Sunburst()),
    	new DemoChart("Histogram", new Histogram()),
    	new DemoChart("Dumbbell Series", new DumbbellSeries()),
    	new DemoChart("Funnel Chart", new FunnelChart()),
    	new DemoChart("Real time Sorting", new RealtimeSorting()),	
    	
    	// Addons - Regression
    	new DemoChart("Addons - Regression"),
    	new DemoChart("Basic Regression", new BasicRegression())
		));

	/**
	 * 
	 * @return
	 */
	public static final List<DemoChart> getDemoChartsList() {
		return demoChartsList;
	}

}
