package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.Stop;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.ZoomType;
import com.hyjavacharts.model.highcharts.series.SeriesArearange;
import com.webonlineapp.hyjavachartsdemo11.chartdata.AreaRangeData;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class AreaRange extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.AREARANGE)
			.getZooming().setType(ZoomType.X);
        chartOptions.getChart().getScrollablePlotArea().setMinWidth(600).setScrollPositionX(1);
		
		chartOptions.getTitle().setText("Temperature variation by day");
        
		chartOptions.getXAxisSingle().setType(AxisType.DATETIME).getAccessibility().setRangeDescription("Range: Jan 1st 2017 to Dec 31 2017.");
		chartOptions.getYAxisSingle().getTitle().setText(null);

		chartOptions.getTooltip().setCrosshairs(true).setShared(true).setValueSuffix("°C").setXDateFormat("%A, %b %e");
		chartOptions.getLegend().setEnabled(false);
		
		SeriesArearange seriesArearange = new SeriesArearange();
		seriesArearange.setName("Temperatures");
		seriesArearange.getColor().getLinearGradient().setX1(0).setX2(0).setY1(0).setY2(1);
		seriesArearange.getColor().setStops(Arrays.asList(new Stop(0, new Color("#ff0000")), new Stop(1, new Color("#0000ff"))));
		seriesArearange.getLabel().setEnabled(false);
		seriesArearange.getDataAsJsValue().setJsValue(new AreaRangeData().get());
		chartOptions.getSeries().add(seriesArearange);
		
		return highChart;
	}

}
