package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.Stacking;
import com.hyjavacharts.model.highcharts.series.SeriesBar;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class BarComparison extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.BAR);
		chartOptions.getTitle().setText("Swedish top 10 professions dominated by women (16-64 years) in 2017");
		chartOptions.getSubtitle().setText("Source: <a href=\"https://www.scb.se/\">Swedish National Statistics</a>");
		
//		chartOptions.setColors(Arrays.asList(new Color("#01BAF2"), new Color("#71BF45"), new Color("#FAA74B")));

		XAxis xAxis = new XAxis();
		xAxis.setCategories(Arrays.asList("Preschool teacher", "Home care nurse", "  Nurse   ", "Nanny", "Nurse practitioner", "Finance Assistant", "Accountant", "  Nurse assistant", "Office assistant/secretary"));
		chartOptions.getXAxis().add(xAxis);
		
		YAxis yAxis = new YAxis();
		yAxis.setMin(0).getTitle().setText(null);
		yAxis.getLabels().setFormat("{value} %");
		chartOptions.getYAxis().add(yAxis);

		chartOptions.getTooltip()
			.setShared(true)
			.setPointFormat("<span style=\"color:{series.color}\">{series.name}</span>: <b>{point.percentage:.0f}%</b><br/>");

		chartOptions.getPlotOptions().getBar().setStacking(Stacking.PERCENT);
		
		SeriesBar seriesBar = new SeriesBar();
		seriesBar.setName("Men");
		seriesBar.setDataAsArrayNumber(Arrays.asList(4, 8, 9, 11, 11, 13, 21, 22, 22));
		chartOptions.getSeries().add(seriesBar);
		
		seriesBar = new SeriesBar();
		seriesBar.setName("Women");
		seriesBar.setDataAsArrayNumber(Arrays.asList(96, 92, 91, 89, 89, 87, 79, 78, 78));
		chartOptions.getSeries().add(seriesBar);
		
		return highChart;
	}
	
}
