package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesColumn;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class BasicColumn extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.COLUMN);
		chartOptions.getTitle().setText("Corn vs wheat estimated production for 2020").setAlign(HorizontalAlign.LEFT);
		chartOptions.getSubtitle().setText("Source: <a target=\"_blank\" href=\"https://www.indexmundi.com/agriculture/?commodity=corn\">indexmundi</a>")
			.setAlign(HorizontalAlign.LEFT);

		XAxis xAxi = new XAxis();
		xAxi.setCrosshair(true)
			.setCategories(Arrays.asList("USA", "China", "Brazil", "EU", "India", "Russia"))
			.getAccessibility().setDescription("Countries");
		chartOptions.getXAxis().add(xAxi);

		YAxis yAxi = new YAxis();
		yAxi.setMin(0).getTitle().setText("1000 metric tons (MT)");
		chartOptions.getYAxis().add(yAxi);
		
		chartOptions.getTooltip().setValueSuffix(" (1000 MT)");

		chartOptions.getPlotOptions().getColumn().setPointPadding(0.2).setBorderWidth(0);
		
		SeriesColumn seriesColumn = new SeriesColumn();
		seriesColumn.setName("Corn");
		seriesColumn.setDataAsArrayNumber(Arrays.asList(406292, 260000, 107000, 68300, 27500, 14500));
		chartOptions.getSeries().add(seriesColumn);
		
		seriesColumn = new SeriesColumn();
		seriesColumn.setName("Wheat");
		seriesColumn.setDataAsArrayNumber(Arrays.asList(51086, 136000, 5500, 141000, 107180, 77000));
		chartOptions.getSeries().add(seriesColumn);
		
		return highChart;
	}

}
