package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesFunnel;
import com.hyjavacharts.model.highcharts.series.seriesfunnel.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class FunnelChart extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.FUNNEL);
		chartOptions.getTitle().setText("Sales funnel");
		
		chartOptions.getPlotOptions()
			.getFunnel()
				.setCenterAsArrayString(Arrays.asList("40%", "50%"))
				.setNeckWidth("30%")
				.setNeckHeight("25%")
				.setWidth("80%")
				.getDataLabels()
					.setEnabled(true)
					.setFormat("<b>{point.name}</b> ({point.y:,.0f})")
					.setColor(new Color().setColorValue("(Highcharts.theme && Highcharts.theme.contrastTextColor) || 'black'"))
					.setSoftConnector(true);
		
		chartOptions.getLegend().setEnabled(false);
		
		SeriesFunnel seriesFunnel = new SeriesFunnel();
		seriesFunnel.setName("Unique users");
		seriesFunnel.setDataAsArrayObject(Arrays.asList(
				new Data().setName("Website visits").setY(15654),
				new Data().setName("Downloads").setY(4064),
				new Data().setName("Requested price list").setY(1987),
				new Data().setName("Invoice sent").setY(976),
				new Data().setName("Finalized").setY(846)
			));
		chartOptions.getSeries().add(seriesFunnel);
		
		return highChart;
	}
	
}
