package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.Key;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.constants.VerticalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesTreegraph;
import com.hyjavacharts.model.highcharts.series.seriestreegraph.Data;
import com.hyjavacharts.model.highcharts.series.seriestreegraph.Levels;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class InvertedTreegraph extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setInverted(true).setMarginBottom(170);
		chartOptions.getTitle().setText("Inverted treegraph").setAlign(HorizontalAlign.LEFT);

		SeriesTreegraph seriesTreegraph = new SeriesTreegraph();
		seriesTreegraph.setType(SeriesType.TREEGRAPH);
		seriesTreegraph.getTooltip().setPointFormat("{point.name}");
		seriesTreegraph.getDataLabels().setPointFormat("{point.name}").setCrop(false)
			.getStyle().setWhiteSpace("nowrap").setColor(new Color("#000000")).setTextOutline("3px contrast");
		seriesTreegraph.getMarker().setRadius(6);
		
		Levels level = new Levels();
		level.setLevel(1).getDataLabels().setAlign(HorizontalAlign.LEFT).setX(20);
		seriesTreegraph.getLevels().add(level);
		
		level = new Levels();
		level.setLevel(2).setColorByPoint(true).getDataLabels().setVerticalAlign(VerticalAlign.BOTTOM).setY(-20);;
		seriesTreegraph.getLevels().add(level);
		
		level = new Levels();
		level.setLevel(3).getColorVariation().setKey(Key.BRIGHTNESS).setTo(-0.5);
		level.getDataLabels().setAlign(HorizontalAlign.LEFT).setRotation(90).setY(20);
		seriesTreegraph.getLevels().add(level);

		seriesTreegraph.setDataAsArrayObject(getSeriesData());
		chartOptions.getSeries().add(seriesTreegraph);
		
		return highChart;
	}
	
	/**
	 * 
	 * @return
	 */
	private ArrayList<Data> getSeriesData() {
		ArrayList<Data> array = new ArrayList<Data>();
		
		array.add(new Data().setId("0.0").setParent("").setName("The World"));
		array.add(new Data().setId("1.3").setParent("0.0").setName("Asia"));
		array.add(new Data().setId("1.1").setParent("0.0").setName("Africa"));
		array.add(new Data().setId("1.2").setParent("0.0").setName("America"));
		array.add(new Data().setId("1.4").setParent("0.0").setName("Europe"));
		array.add(new Data().setId("1.5").setParent("0.0").setName("Oceanic"));
		array.add(new Data().setId("2.1").setParent("1.1").setName("Eastern Africa"));
		array.add(new Data().setId("2.5").setParent("1.1").setName("Western Africa"));
		array.add(new Data().setId("2.3").setParent("1.1").setName("North Africa"));
		array.add(new Data().setId("2.2").setParent("1.1").setName("Central Africa"));
		array.add(new Data().setId("2.4").setParent("1.1").setName("South America"));
		array.add(new Data().setId("2.9").setParent("1.2").setName("South America"));
		array.add(new Data().setId("2.8").setParent("1.2").setName("Northern America"));
		array.add(new Data().setId("2.7").setParent("1.2").setName("Central America"));
		array.add(new Data().setId("2.6").setParent("1.2").setName("Caribbean"));
		array.add(new Data().setId("2.13").setParent("1.3").setName("Southern Asia"));
		array.add(new Data().setId("2.11").setParent("1.3").setName("Eastern Asia"));
		array.add(new Data().setId("2.12").setParent("1.3").setName("South-Eastern Asia"));
		array.add(new Data().setId("2.14").setParent("1.3").setName("Western Asia"));
		array.add(new Data().setId("2.10").setParent("1.3").setName("Central Asia"));
		array.add(new Data().setId("2.15").setParent("1.4").setName("Eastern Europe"));
		array.add(new Data().setId("2.16").setParent("1.4").setName("Northern Europe"));
		array.add(new Data().setId("2.17").setParent("1.4").setName("Southern Europe"));
		array.add(new Data().setId("2.18").setParent("1.4").setName("Western Europe"));
		array.add(new Data().setId("2.19").setParent("1.5").setName("Australia and New Zealand"));
		array.add(new Data().setId("2.20").setParent("1.5").setName("Melanesia"));
		array.add(new Data().setId("2.21").setParent("1.5").setName("Micronesia"));
		array.add(new Data().setId("2.22").setParent("1.5").setName("Polynesia"));
		
		return array;
    }
	
}
