package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Function;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesSpline;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class Notifications extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.SPLINE);
		chartOptions.getTitle().setText("Sonify series in order").setAlign(HorizontalAlign.LEFT).setMargin(25);
		chartOptions.getSubtitle().setText("Earcons/announcements played on begin/end events").setAlign(HorizontalAlign.LEFT);
		
		chartOptions.getSonification().setDuration(7500).getEvents()
			.setOnSeriesStart(new Function("e.series.chart.sonification.speak(e.series.name, {rate: 2.5,volume: 0.3});", "e"))
			.setOnSeriesEnd(new Function("e.series.chart.sonification.playNote('chop', {note: 0, pan: 1, volume: 1.2}, 80);", "e"))
			.setOnEnd(new Function("var playNote = function (note, time) {e.chart.sonification.playNote('vibraphone', {note: note, noteDuration: 400, pan: 0, volume: 0.4}, time);}; playNote('c6', 40); playNote('g6', 200); e.chart.sonification.speak('End', { rate: 2, volume: 0.3}, 400);", "e"));;

		SeriesSpline seriesSpline = new SeriesSpline();
		seriesSpline.setDataAsArrayNumber(Arrays.asList(1, 2, 4, 6, 9, 12, 15, 16));
		chartOptions.getSeries().add(seriesSpline);
		
		seriesSpline = new SeriesSpline();
		seriesSpline.setDataAsArrayNumber(Arrays.asList(12, 10, 9, 5, 2, 1, 2, 3));
		chartOptions.getSeries().add(seriesSpline);
		
		seriesSpline = new SeriesSpline();
		seriesSpline.setDataAsArrayNumber(Arrays.asList(2, 2, 2, 7, 16, 6, 2, 1));
		chartOptions.getSeries().add(seriesSpline);
		
		this.setAudio(true);
		
		return highChart;
	}

}
