package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.Function;
import com.hyjavacharts.model.common.GenericOption;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesBar;
import com.hyjavacharts.model.highcharts.series.seriesbar.Zones;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;
import com.webonlineapp.hyjavachartsdemo11.services.RestService;

public class RealtimeSorting extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getChart().setType(ChartType.BAR).setMarginLeft(100).getEvents().setLoad(new Function("runcounter = 0;"));
		chartOptions.getTitle().setText("Bar series - data sorting");
		chartOptions.getSubtitle().setText("(will stop after 60 seconds)");
	
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("");
		chartOptions.getYAxis().add(yAxi);
		
		XAxis xAxi = new XAxis();
		xAxi.setType(AxisType.CATEGORY).setMin(0);
		xAxi.getLabels().get_genericOption().add(new GenericOption("animate", "true"));
		chartOptions.getXAxis().add(xAxi);
	
		chartOptions.getLegend().setEnabled(false);

		SeriesBar seriesBar = new SeriesBar();
		seriesBar.setZoneAxis("x").getZones().add(new Zones().setValue(1).setColor(new Color("#ff4d40")));
		seriesBar.getDataLabels().setEnabled(true).setFormat("{y:,.2f}");
		seriesBar.getDataSorting().setEnabled(true).setSortKey("y");
		chartOptions.getSeries().add(seriesBar);
		
		// Some of our example charts use a REST service to retrieve data.
		chartOptions.getData().setCsvURL(RestService.getURI() + "/RealtimeSortingCSVData")
			.setEnablePolling(true)
			.setDataRefreshRate(3)
			.setComplete(new Function("runcounter++; if (runcounter > 20) { chart.destroy(); }"));

		return highChart;
	}
	
}
