package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.Symbol;
import com.hyjavacharts.model.highcharts.series.SeriesScatter;
import com.hyjavacharts.model.highcharts.series.seriesscatter.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class ScatterPlotWithJitter extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();

		chartOptions.getChart().setType(ChartType.SCATTER);
		chartOptions.getTitle().setText("Scatter chart with jitter");

		chartOptions.getXAxisSingle().setCategories(
			Arrays.asList("Run 1", "Run 2", "Run 3", "Run 4", "Run 5"));
		chartOptions.getYAxisSingle().getTitle().setText("Measurements");

		chartOptions.getPlotOptions().getScatter()
			.setShowInLegend(false)
			.getJitter()
				.setX(0.24).setY(0);
		chartOptions.getPlotOptions().getScatter()
			.getMarker()
				.setRadius(2)
				.setSymbol(Symbol.CIRCLE);
		chartOptions.getPlotOptions().getScatter()
			.getTooltip()
				.setPointFormat("Measurement: {point.y:.3f}");
		
		SeriesScatter seriesScatter = new SeriesScatter();
		seriesScatter.setName("Run 1").setColor(new Color().setRGBA(124, 181, 236, .5));
		seriesScatter.setDataAsArrayObject(getTestData(0));
		chartOptions.getSeries().add(seriesScatter);
		
		seriesScatter = new SeriesScatter();
		seriesScatter.setName("Run 2").setColor(new Color().setRGBA(67, 67, 72, .5));
		seriesScatter.setDataAsArrayObject(getTestData(1));
		chartOptions.getSeries().add(seriesScatter);
		
		seriesScatter = new SeriesScatter();
		seriesScatter.setName("Run 3").setColor(new Color().setRGBA(144, 237, 125, .5));
		seriesScatter.setDataAsArrayObject(getTestData(2));
		chartOptions.getSeries().add(seriesScatter);
		
		seriesScatter = new SeriesScatter();
		seriesScatter.setName("Run 4").setColor(new Color().setRGBA(247, 163, 92, .5));
		seriesScatter.setDataAsArrayObject(getTestData(3));
		chartOptions.getSeries().add(seriesScatter);
		
		seriesScatter = new SeriesScatter();
		seriesScatter.setName("Run 5").setColor(new Color().setRGBA(128, 133, 233, .5));
		seriesScatter.setDataAsArrayObject(getTestData(4));
		chartOptions.getSeries().add(seriesScatter);
		
		return highChart;
	}

	/**
	 * 
	 * @param x
	 * @return
	 */
	private List<Data> getTestData(int x) {
		List<Data> testData = new ArrayList<Data>();
		double off = 0.2 + 0.2 * Math.random();

		for (int i = 0; i < 200; i++) {
			testData.add(new Data().setX(x).setY(off + (Math.random() - 0.5) * (Math.random() - 0.5)));
		}
		
		return testData;
	}
	
}
