package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.hyjavacharts.model.highcharts.series.SeriesScatter;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class ScatterWithTrendLine extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Scatter plot with trend line");

		XAxis xAxi = new XAxis();
		xAxi.setMin(-0.5).setMax(5.5);
		chartOptions.getXAxis().add(xAxi);

		YAxis yAxi = new YAxis();
		yAxi.setMin(0);
		chartOptions.getYAxis().add(yAxi);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.getLabel().setEnabled(false);
		seriesLine.setType(SeriesType.LINE)
			.setName("Trend Line")
			.setEnableMouseTracking(false)
			.getMarker().setEnabled(false);
		seriesLine.getStates().getHover().setLineWidth(0);
		seriesLine.setDataAsArrayJavaObject(getSeriesData(1));
		chartOptions.getSeries().add(seriesLine);

		SeriesScatter seriesScatter = new SeriesScatter();
		seriesScatter.setType(SeriesType.SCATTER)
			.setName("Observations")
			.getMarker().setRadius(4);
		seriesScatter.setDataAsArrayJavaObject(getSeriesData(2));
		chartOptions.getSeries().add(seriesScatter);
		
		return highChart;
	}
	
	/**
	 * 
	 * @param series
	 * @return
	 */
	private ArrayList<Object> getSeriesData(int series) {
		ArrayList<Object> array = new ArrayList<Object>();
		
    	if (series == 1) {
    		array.add(Arrays.asList(-0.2, 5.078957867858279));
    		array.add(Arrays.asList(5.1,  3.5915576125119726));
    	}
    	else if (series == 2) {
    		array.add(Arrays.asList(1.4, 0.4));
    		array.add(Arrays.asList(2.4, 5.3));
    		array.add(Arrays.asList(2.9, 4.9));
    		array.add(Arrays.asList(5, 2.3));
    		array.add(Arrays.asList(3.6, 1.9));
    		array.add(Arrays.asList(5.1, 6.1));
    		array.add(Arrays.asList(2, 4));
    		array.add(Arrays.asList(2, 5.6));
    		array.add(Arrays.asList(-0.2, 6.3));
    		array.add(Arrays.asList(1.2, 6.3));
    	}

    	return array;
    }
}
