package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.constants.VerticalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesPie;
import com.hyjavacharts.model.highcharts.series.seriespie.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class SemiCircleDonut extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart()
			.setPlotBackgroundColor(null)
			.setPlotBorderWidth(0)
			.setPlotShadow(false);
		
		chartOptions.getTitle().setText("Browser<br>shares<br>January<br>2022")
			.setAlign(HorizontalAlign.CENTER)
			.setVerticalAlign(VerticalAlign.MIDDLE)
			.setY(60)
			.getStyle().setFontSize("1.1em");

		chartOptions.getTooltip().setPointFormat("{series.name}: <b>{point.percentage:.1f}%</b>");
		chartOptions.getAccessibility().getPoint().setValueSuffix("%");
		
		chartOptions.getPlotOptions()
			.getPie()
				.setStartAngle(-90)
				.setEndAngle(90)
				.setCenterAsArrayString(Arrays.asList("50%", "75%"))
				.setSize("110%")
				.getDataLabels()
					.setEnabled(true)
					.setDistance(-50)
					.getStyle()
						.setFontWeight("bold")
						.setColor(new Color("white"));
		
		SeriesPie seriesPie = new SeriesPie();
		seriesPie.setType(SeriesType.PIE)
			.setName("Browser share")
			.setInnerSize("50%");
		seriesPie.setDataAsArrayObject(getSeriesData());
		chartOptions.getSeries().add(seriesPie);
		
		return highChart;
	}
	
	/**
	 * 
	 * @param series
	 * @return
	 */
	private ArrayList<Data> getSeriesData() {
		ArrayList<Data> array = new ArrayList<Data>();
		
		array.add(new Data().setName("Chrome").setY(73.86));
		array.add(new Data().setName("Edge").setY(11.97));
		array.add(new Data().setName("Firefox").setY(5.52));
		array.add(new Data().setName("Safari").setY(2.98));
		array.add(new Data().setName("Internet Explorer").setY(1.90));
		array.add(new Data().setName("Other").setY(3.77));
		
		return array;
    }
}
