package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesScatter;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class TimeMapping extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.SCATTER);
		
		chartOptions.getTitle().setText("Time mapping").setAlign(HorizontalAlign.LEFT).setMargin(25);
		chartOptions.getSubtitle().setText("Time mapping").setAlign(HorizontalAlign.LEFT);
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getTooltip().setHeaderFormat("").setPointFormat("{point.x},{point.y}");
        		 
		SeriesScatter seriesScatter = new SeriesScatter();
		seriesScatter.setColor(new Color(30, 30, 200, 0.7)).getMarker().setRadius(5);
		seriesScatter.getDataAsJsValue().setJsValue("[[16, -5], [7, -4],[19, -3],[3, -2],[21, -1],[-2, 0],[7, 1],[-3, 2],[16, 3],[17, 4],[11, 5],[-1, 6]]");
		chartOptions.getSeries().add(seriesScatter);
		
		chartOptions.getSonification().setDuration(4000)
			.getDefaultInstrumentOptions()
				.getMapping().setTime("y");
		
		this.setAudio(true);
		
		return highChart;
	}

}
