package com.webonlineapp.hyjavachartsdemo11.util;

import com.vaadin.flow.component.Component;
import com.vaadin.flow.component.Tag;


@Tag(value = "vaadin-icon")
public class DesignerIcon extends Component {
	private static final long serialVersionUID = 1L;
	
	private static final String ICON_ATTRIBUTE_NAME = "icon";

    /**
     * Creates an Icon component that displays the given {@code icon} from the
     * given {@code collection}.
     *
     * @param collection
     *            the icon collection
     * @param icon
     *            the icon name
     */
    public DesignerIcon(String collection, String icon) {
        // iron-icon's icon-attribute uses the format "collection:name",
        // e.g. icon="vaadin:arrow-down"
        getElement().setAttribute(ICON_ATTRIBUTE_NAME, collection + ':' + icon);
    }

}
