package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesColumn;
import com.hyjavacharts.model.highcharts.series.seriescolumn.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class BreadcrumbsSingleButton extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();

		chartOptions.getChart().setType(ChartType.COLUMN);
		chartOptions.getXAxisSingle().setType(AxisType.CATEGORY);
		chartOptions.getTitle().setText("Breadcrumbs, single button style");
		
		SeriesColumn seriesColumn = new SeriesColumn();
		seriesColumn.setName("Supply");
		seriesColumn.setDataAsArrayObject(Arrays.asList(
			new Data().setName("Fruits").setY(5).setDrilldown("Fruits"),
			new Data().setName("Vegetables").setY(6).setDrilldown("Vegetables"),
			new Data().setName("Meat").setY(3)
				));
		chartOptions.getSeries().add(seriesColumn);
		
		chartOptions.getDrilldown().getBreadcrumbs().setFloating(true).setShowFullPath(false)
			.getButtonTheme()
				.setFill(new Color("#f7f7f7")).setPadding(8).setStroke(new Color("#cccccc")).setStrokeWidthHyphenated(1);
		chartOptions.getDrilldown().getBreadcrumbs().getPosition().setAlign(HorizontalAlign.RIGHT);

		SeriesColumn seriesDrilldownColumn = new SeriesColumn();
		seriesDrilldownColumn.setName("Fruits").setId("Fruits").setDataAsArrayObject(Arrays.asList(
			new Data().setName("Citrus").setY(2).setDrilldown("Citrus"),
			new Data().setName("Tropical").setY(5).setDrilldown("Tropical"),
			new Data().setName("Other").setY(1)
				));
		chartOptions.getDrilldown().getSeries().add(seriesDrilldownColumn);
		
		seriesDrilldownColumn = new SeriesColumn();
		seriesDrilldownColumn.setName("Vegetables").setId("Vegetables").setDataAsArrayObject(Arrays.asList(
			new Data().setName("Potatoes").setY(2),
			new Data().setName("Cucumber").setY(4)
				));
		chartOptions.getDrilldown().getSeries().add(seriesDrilldownColumn);
		
		seriesDrilldownColumn = new SeriesColumn();
		seriesDrilldownColumn.setName("Citrus").setId("Citrus").setDataAsArrayObject(Arrays.asList(
			new Data().setName("Lemon").setY(5).setDrilldown("Lemon"),
			new Data().setName("Orange").setY(4)
				));
		chartOptions.getDrilldown().getSeries().add(seriesDrilldownColumn);
		
		seriesDrilldownColumn = new SeriesColumn();
		seriesDrilldownColumn.setName("Tropical").setId("Tropical").setDataAsArrayObject(Arrays.asList(
			new Data().setName("Banana").setY(1),
			new Data().setName("Mango").setY(3)
				));
		chartOptions.getDrilldown().getSeries().add(seriesDrilldownColumn);
		
		seriesDrilldownColumn = new SeriesColumn();
		seriesDrilldownColumn.setName("Lemon").setId("Lemon").setDataAsArrayObject(Arrays.asList(
			new Data().setName("Typ A").setY(2),
			new Data().setName("Typ B").setY(7)
				));
		chartOptions.getDrilldown().getSeries().add(seriesDrilldownColumn);

		return highChart;
	}
	
}
