package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.sonification.Tracks;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.hyjavacharts.model.highcharts.series.seriesline.Zones;
import com.hyjavacharts.model.highcharts.yaxis.PlotLines;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class ConditionalTracks extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Mapping zones").setAlign(HorizontalAlign.LEFT).setMargin(25);
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getYAxisSingle().getPlotLines()
			.add(new PlotLines().setValue(6).setColor(new Color("#565")).setWidth(3).setZIndex(2));
		chartOptions.getYAxisSingle().getPlotLines()
			.add(new PlotLines().setValue(10).setColor(new Color("#565")).setWidth(3).setZIndex(2));

		SeriesLine seriesLine = new SeriesLine();
		Tracks track = new Tracks();
		track.setInstrument("vibraphone").getActiveWhenAsObject().setProp("y").setMax(6);
		seriesLine.getSonification().getTracks().add(track);
		
		track = new Tracks();
		track.setInstrument("piano").getActiveWhenAsObject().setProp("y").setMin(6.1).setMax(10);
		seriesLine.getSonification().getTracks().add(track);
		
		track = new Tracks();
		track.setInstrument("saxophone").getActiveWhenAsObject().setProp("y").setMin(10.1);
		seriesLine.getSonification().getTracks().add(track);

		seriesLine.setDataAsArrayNumber(Arrays.asList(4, 5, 6, 5, 7, 8, 7, 9, 11, 13, 14, 11, 8,
	            										7, 5, 2, 2, 1, 6, 8, 9, 11));

		seriesLine.getZones().add(new Zones().setColor(new Color("#3C3CC3")).setValue(6.1));
		seriesLine.getZones().add(new Zones().setColor(new Color("#34A866")).setValue(10.1));
		seriesLine.getZones().add(new Zones().setColor(new Color("#DD1903")));
		chartOptions.getSeries().add(seriesLine);
		
		this.setAudio(true);
		
		return highChart;
	}

}
