package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.LandmarkVerbosity;
import com.hyjavacharts.model.highcharts.constants.SonificationOrder;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class InSequence extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Chart sonified in sequence")
			.setAlign(HorizontalAlign.LEFT).setMargin(25);
	
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getAccessibility().setLandmarkVerbosity(LandmarkVerbosity.ONE);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayNumber(Arrays.asList(4, 5, 6, 5, 7, 9, 11, 13));
		chartOptions.getSeries().add(seriesLine);
	        
		seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayNumber(Arrays.asList(1, 3, 4, 2));
		chartOptions.getSeries().add(seriesLine);
		
		chartOptions.getSonification().setOrder(SonificationOrder.SEQUENTIAL).setDuration(3000);
		
		this.setAudio(true);
		
		return highChart;
	}

}
