package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.DashStyle;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.hyjavacharts.model.highcharts.series.seriesline.Zones;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class LineWithZones extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
	    
		chartOptions.getTitle().setText("Basic Line With Color by Zones");
	
		YAxis yAxi = new YAxis();
		yAxi.getTitle().setText("Sales Number");
		yAxi.getPlotLinesSingle()
			.setColor(new Color("black")).setDashStyle(DashStyle.LONGDASH).setValue(93).setWidth(1)
				.getLabel().setText("Break Even Point");
		chartOptions.getYAxis().add(yAxi);
		
		XAxis xAxi = new XAxis();
        xAxi.setCategories(
            Arrays.asList("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"));
        chartOptions.getXAxis().add(xAxi);
        
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.getLabel().setEnabled(false);
		seriesLine.setName("Widget Sales");
		
		seriesLine.getZones().add(new Zones().setValue(93).setColor(new Color("red")));
		seriesLine.getZones().add(new Zones().setColor(new Color("green")));
		
		seriesLine.setDataAsArrayNumber(Arrays.asList(0, 0, 50, 100, 200, 200, 100, 50, 0, 0));
		chartOptions.getSeries().add(seriesLine);
		
		return highChart;
	}
	
}
