package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.common.Function;
import com.hyjavacharts.model.common.LinearGradient;
import com.hyjavacharts.model.common.NullOption;
import com.hyjavacharts.model.common.Stop;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;
import com.webonlineapp.hyjavachartsdemo11.services.RestService;

public class LiveDataFromDynamicCSV extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.AREASPLINE).getEvents().setLoad(new Function("runcounter = 0;"));
		chartOptions.getTitle().setText("Live Data (CSV)");
		chartOptions.getSubtitle().setText("(will stop after 60 seconds)");
		
		chartOptions.getAccessibility().getAnnounceNewData().setEnabled(true).setMinAnnounceInterval(15000)
			.setAnnouncementFormatter(new Function("if (newPoint) { return 'New point added. Value: ' + newPoint.y; } return false;", "allSeries", "newSeries", "newPoint"));

		chartOptions.getPlotOptions().getAreaspline().getLabel().setEnabled(false);
		chartOptions.getPlotOptions().getAreaspline().setColor(new Color("#32CD32")).setThreshold(NullOption.NULL_NUMBER)
			.getMarker().setLineWidth(1).setLineColor(null).setFillColor(new Color("white"));
		
		chartOptions.getPlotOptions().getAreaspline()
			.setFillColor(new Color(new LinearGradient(0, 0, 0, 1), 
									Arrays.asList(new Stop(0, new Color("#32CD32")), new Stop(1, new Color("#32CD3200")))));
		
		
		// Some of our example charts use a REST service to retrieve data.
		chartOptions.getData().setCsvURL(RestService.getURI() + "/LiveDataCSVData")
			.setEnablePolling(true)
			.setComplete(new Function("runcounter++; if (runcounter > 60) { chart.destroy(); }"));
		
		return highChart;
	}

}
