package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.MapFunction;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class LogarithmicPitchMapping extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Logarithmic pitch mapping").setAlign(HorizontalAlign.LEFT).setMargin(25);;
		chartOptions.getLegend().setEnabled(false);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setType(SeriesType.LINE)
			.setDataAsArrayNumber(Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11,
		            12, 13, 14, 15, 16, 17, 18, 19, 20,
		            21, 22, 23, 24, 25));
		chartOptions.getSeries().add(seriesLine);
		
		chartOptions.getSonification().setDuration(4000)
			.getDefaultInstrumentOptions()
				.getMapping().getPitchAsObject().setMapFunction(MapFunction.LOGARITHMIC).setMin("c3").setMax("c5");
		
		this.setAudio(true);
		
		return highChart;
	}

}
