package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.XAxis;
import com.hyjavacharts.model.highcharts.YAxis;
import com.hyjavacharts.model.highcharts.constants.AxisType;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.series.SeriesLollipop;
import com.hyjavacharts.model.highcharts.series.serieslollipop.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class LollipopSeries extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.LOLLIPOP);
		chartOptions.getTitle().setText("Top 10 Countries by Population");
		chartOptions.getSubtitle().setText("2018");
		
		chartOptions.getLegend().setEnabled(false);
		chartOptions.getTooltip().setShared(true);

		XAxis xAxis = new XAxis();
		xAxis.setType(AxisType.CATEGORY);
		chartOptions.getXAxis().add(xAxis);

		YAxis yAxis = new YAxis();
		yAxis.getTitle().setText("Population");
		chartOptions.getYAxis().add(yAxis);

		SeriesLollipop seriesLollipop = new SeriesLollipop();
		seriesLollipop.setName("Population");
		seriesLollipop.setDataAsArrayObject(Arrays.asList(
				new Data().setName("China").setY(1427647786),
				new Data().setName("India").setY(1352642280),
				new Data().setName("United States").setY(327096265),
				new Data().setName("Indonesia").setY(267670543),
				new Data().setName("Pakistan").setY(212228286),
				new Data().setName("Brazil").setY(209469323),
				new Data().setName("Nigeria").setY(195874683),
				new Data().setName("Bangladesh").setY(161376708),
				new Data().setName("Russia").setY(145734038),
				new Data().setName("Mexico").setY(126190788)
				));
		chartOptions.getSeries().add(seriesLollipop);
		
		return highChart;
	}
	
}
