package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.LandmarkVerbosity;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class MappingPitchtoData extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Mapping Pitch to Data").setAlign(HorizontalAlign.LEFT);
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getAccessibility().setLandmarkVerbosity(LandmarkVerbosity.ONE)
			.getSeries().setDescribeSingleSeries(true);
	
		chartOptions.getTooltip().setHeaderFormat("").setPointFormat("<b>{point.y}</b>").setPadding(10);
		
		chartOptions.getXAxisSingle().getCrosshairAsObject().setWidth(50)
			.setColor(new Color().setRGBA(90, 140, 210, 0.1));
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setType(SeriesType.LINE).setColor(new Color("#3070d0"))
			.setDataAsArrayNumber(Arrays.asList(1, 2, 2, 4, 5, 7, 9, 11, 13, 6, 7, 1));
		chartOptions.getSeries().add(seriesLine);

		chartOptions.getSonification().setDuration(4000)
			.getDefaultInstrumentOptions().setInstrument("piano")
				.getMapping().setVolume(0.4).setPan(0).setNoteDuration(4500)
				.getPitchAsObject().setMapTo("y").setMin("c2").setMax("c6");
		
		this.setAudio(true);
		
		return highChart;
	}

}
