package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.LandmarkVerbosity;
import com.hyjavacharts.model.highcharts.constants.MapFunction;
import com.hyjavacharts.model.highcharts.constants.SeriesType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class MusicalScales extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Musical scales").setAlign(HorizontalAlign.LEFT).setMargin(25);
		chartOptions.getSubtitle().setText("Minor").setAlign(HorizontalAlign.LEFT);
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getAccessibility().setLandmarkVerbosity(LandmarkVerbosity.ONE);
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setType(SeriesType.LINE)
			.setDataAsArrayNumber(Arrays.asList(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15,
		            14, 13, 12, 11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1));
		chartOptions.getSeries().add(seriesLine);
		
		chartOptions.getSonification().setDuration(3500)
			.getDefaultInstrumentOptions()
				.getMapping().setNoteDuration(300)
				.getPitchAsObject().setMapFunction(MapFunction.LOGARITHMIC).setMin("c4").setMax("c6")
				.setScale(Arrays.asList(0, 1, 5, 7, 8, 10, 11))
				.getScaleAsJsValue().setJsValue("Highcharts.sonification.Scales.minor");
		
		this.setAudio(true);
		
		return highChart;
	}

}
