package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.Cursor;
import com.hyjavacharts.model.highcharts.plotoptions.series.DataLabels;
import com.hyjavacharts.model.highcharts.series.SeriesPie;
import com.hyjavacharts.model.highcharts.series.seriespie.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class PieChart extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
				
		chartOptions.getChart().setType(ChartType.PIE);
		
		chartOptions.getTitle().setText("Egg Yolk Composition");
		chartOptions.getSubtitle().setText("Source:<a href=\"https://www.mdpi.com/2072-6643/11/3/684/htm\" target=\"_default\">MDPI</a>");

		chartOptions.getTooltip().setValueSuffix("%");
		
		chartOptions.getPlotOptions().getSeries().setAllowPointSelect(true).setCursor(Cursor.POINTER);
		
		List<DataLabels> dataLabelsList = new ArrayList<DataLabels>();
		
		DataLabels dl = new DataLabels();
		dl.setEnabled(true).setDistance(20);
		dataLabelsList.add(dl);
		
		dl = new DataLabels();
		dl.setEnabled(true).setFormat("{point.percentage:.1f}%").setDistance(-40).getStyle().setFontSize("1.2em").setTextOutline("none").setOpacity(0.7);
		dl.getFilter().setOperator(">").setProperty("percentage").setValue(10);
		dataLabelsList.add(dl);
		
		chartOptions.getPlotOptions().getSeries().setDataLabels(dataLabelsList);

		SeriesPie seriesPie = new SeriesPie();
		seriesPie.setName("Percentage").setColorByPoint(true);
		seriesPie.setDataAsArrayObject(Arrays.asList(new Data().setName("Water").setY(55.02),
													 new Data().setName("Fat").setY(26.71).setSliced(true).setSelected(true), 
													 new Data().setName("Carbohydrates").setY(1.09),
													 new Data().setName("Protein").setY(15.5),
													 new Data().setName("Ash").setY(1.68)));
		chartOptions.getSeries().add(seriesPie);
		
		return highChart;
	}
	
}
