package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.Cursor;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesPie;
import com.hyjavacharts.model.highcharts.series.seriespie.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class PieWithLegend extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.PIE).setPlotBackgroundColor(null).setBorderWidth(null).setPlotShadow(false);

		chartOptions.getTitle().setText("Browser market shares in March, 2022").setAlign(HorizontalAlign.LEFT);
		chartOptions.getTooltip().setPointFormat("{series.name}: <b>{point.percentage:.1f}%</b>");
		chartOptions.getAccessibility().getPoint().setValueSuffix("%");
		
		chartOptions.getPlotOptions()
			.getPie()
				.setAllowPointSelect(true)
				.setCursor(Cursor.POINTER)
				.setShowInLegend(true)
				.getDataLabels().setEnabled(false);
		
		SeriesPie seriesPie = new SeriesPie();
		seriesPie.setName("Brands").setColorByPoint(true);
		seriesPie.setDataAsArrayObject(getSeriesData());
		chartOptions.getSeries().add(seriesPie);
		
		return highChart;
	}
	
	/**
	 * 
	 * @return
	 */
	private ArrayList<Data> getSeriesData() {
		ArrayList<Data> array = new ArrayList<Data>();
		
		array.add(new Data().setName("Chrome").setY(74.77).setSliced(true).setSelected(true));
		array.add(new Data().setName("Edge").setY(12.82));
		array.add(new Data().setName("Firefox").setY(4.63));
		array.add(new Data().setName("Safari").setY(2.44));
		array.add(new Data().setName("Internet Explorer").setY(2.02));
		array.add(new Data().setName("Other").setY(3.28));

		return array;
	}
}
