package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.LandmarkVerbosity;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class SonifiedFunction extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setMarginTop(40).setMarginLeft(10).setMarginRight(10).setMarginBottom(20);
		chartOptions.getTitle().setText("Sonified mathematical function").setAlign(HorizontalAlign.LEFT);

		chartOptions.getAccessibility().setLandmarkVerbosity(LandmarkVerbosity.ONE);
		chartOptions.getLegend().setEnabled(false);
		
		chartOptions.getXAxisSingle()
			.setMin(-6).setMax(6).setGridLineWidth(1).setTickInterval(1).setLineColor(new Color("#343")).setOffset(-245);

		chartOptions.getYAxisSingle()
			.setMin(-6).setMax(6).setTickInterval(1).setLineWidth(1).setLineColor(new Color("#343")).setOffset(-265)
			.getTitle().setText(null);

		chartOptions.getTooltip().setHeaderFormat("").setPointFormat("y = {point.y:.2f}");

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayJavaObject(getData());

		chartOptions.getSeries().add(seriesLine);

		chartOptions.getSonification().setDuration(8000)
			.getDefaultInstrumentOptions().setInstrument("basic1").setRoundToMusicalNotes(false);
		
		this.setWidth("550px");
		this.setHeight("550px");
		this.setAudio(true);
		
		return highChart;
	}
	
	/**
	 * 
	 * @return
	 */
	private List<Object> getData() {
		List<Object> functionData = new ArrayList<Object>();
		
		for (double x = -6; x < 6; x += 0.01) {
		    functionData.add(Arrays.asList(x, Math.round(x * 100) != 0 ? 1 / x : null));
		}
		
		return functionData;
	}

}
