package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.sonification.Tracks;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.constants.TrackType;
import com.hyjavacharts.model.highcharts.series.SeriesLine;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class SpeechMapping extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getTitle().setText("Speak values").setAlign(HorizontalAlign.LEFT).setMargin(25);
		chartOptions.getLegend().setEnabled(false);

		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setDataAsArrayNumber(Arrays.asList(4, 5, 6, 5, 7, 8, 7, 9, 11, 13, 14, 11, 8));
		
		Tracks track = new Tracks();
		track.setInstrument("vibraphone").getMapping().setVolume(0.9).getPitchAsObject().setMin("c3").setMax("g6");
		seriesLine.getSonification().getTracks().add(track);
		
		track = new Tracks();
		track.setType(TrackType.SPEECH)
			.getMapping().setText("{point.y}").setRate(2).setVolume(1).setPitchAsString("y").setPlayDelay(250);
		seriesLine.getSonification().getTracks().add(track);
		
		chartOptions.getSeries().add(seriesLine);

		chartOptions.getSonification().setDuration(10000);
		
		this.setAudio(true);
		
		return highChart;
	}

}
