package com.webonlineapp.hyjavachartsdemo11.examplecharts;

import java.util.Arrays;

import com.hyjavacharts.chart.Highchart;
import com.hyjavacharts.model.common.Color;
import com.hyjavacharts.model.highcharts.ChartOptions;
import com.hyjavacharts.model.highcharts.constants.ChartType;
import com.hyjavacharts.model.highcharts.constants.HorizontalAlign;
import com.hyjavacharts.model.highcharts.series.SeriesVariablepie;
import com.hyjavacharts.model.highcharts.series.seriesvariablepie.Data;
import com.webonlineapp.hyjavachartsdemo11.charts.DemoChartBase;

public class VariableRadiusPie extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highchart configure() {
		Highchart highChart = new Highchart();
		ChartOptions chartOptions = highChart.getChartOptions();
		
		chartOptions.getChart().setType(ChartType.VARIABLEPIE);
		chartOptions.getTitle().setText("Countries compared by population density and total area, 2022.").setAlign(HorizontalAlign.LEFT);
		
		chartOptions.getTooltip()
			.setHeaderFormat("")
			.setPointFormat("<span style=\"color:{point.color}\">\u25CF</span> <b> {point.name}</b><br/>Area (square km): <b>{point.y}</b><br/>Population density (people per square km): <b>{point.z}</b><br/>");

		SeriesVariablepie seriesVariablepie = new SeriesVariablepie();
		seriesVariablepie.setName("countries")
			.setMinPointSize(10)
			.setInnerSize("20%")
			.setZMin(0)
			.setBorderRadius(5)
			.setColors(Arrays.asList(new Color("#4caefe"), new Color("#3dc3e8"), new Color("#2dd9db"), 
									 new Color("#1feeaf"), new Color("#0ff3a0"), new Color("#00e887"), new Color("#23e274")));

		seriesVariablepie.setDataAsArrayObject(Arrays.asList(
			new Data().setName("Spain").setY(505992).setZ(92),
			new Data().setName("France").setY(551695).setZ(119),
			new Data().setName("Poland").setY(312679).setZ(121),
			new Data().setName("Czech Republic").setY(78865).setZ(136),
			new Data().setName("Italy").setY(301336).setZ(200),
			new Data().setName("Switzerland").setY(41284).setZ(213),
			new Data().setName("Germany").setY(357114).setZ(235)
			));
		chartOptions.getSeries().add(seriesVariablepie);
		
		return highChart;
	}
	
}
