package com.webonlineapp.content;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;

import com.hyjavaapex.chart.Apexchart;

public class ApexChartContent {
	private boolean jcef = false;
	
	
	/**
	 * 
	 */
	public ApexChartContent() {
		
	}
	
	/**
	 * 
	 * @param jcef
	 */
	public ApexChartContent(boolean jcef) {
		this.jcef = jcef;
	}

	/**
	 * 
	 * @param chart
	 * @return
	 */
	public String build(Apexchart chart) {
		String resizeObserver = "";
		if (!jcef) {
			// Apexcharts after v3.29.0 has implemented ResizeObserver which WebView does not support.
			// Need to implement a polyfill to include support: ResizeObserver.js
			resizeObserver = 
				"<script src=file://" +
				FileSystems.getDefault().getPath("src/main/resources/ResizeObserver.js").toAbsolutePath().toString() + ">" +
				"</script>" + System.lineSeparator();
		}
		
		String content = 
			"<!DOCTYPE html>" + System.lineSeparator() + 				// html5
			"<html>" + System.lineSeparator() + 						// start html
			"<head>" + System.lineSeparator() +							// start head
			"<title>chart</title>"+ System.lineSeparator() +			// title
			"</head>" + System.lineSeparator() +						// end head
				   
			"<body>" + System.lineSeparator() +							// start body
			"<div id=\"container\" style=\"min-width: 310px; max-width: 800px; height: 400px; margin: 0 auto\"></div>" + System.lineSeparator() +

			resizeObserver +
				   
			"<script src=https://cdn.jsdelivr.net/npm/apexcharts@3.49.0></script>" + System.lineSeparator() +
				   
			"<script>" + System.lineSeparator() +
			"var chart = new ApexCharts(document.querySelector('#container'), " + chart.chartOptionsToJs() + ");" + System.lineSeparator() +
			"chart.render();" + System.lineSeparator() +
			"</script>" + System.lineSeparator() +
				   
			"</body>" + System.lineSeparator() +						// end body
			"</html>";	

		if (jcef) {
			Path temp = null;
			try {
				temp = Files.createTempFile("chart", ".html");
				Files.write(temp, content.getBytes(StandardCharsets.UTF_8));
				
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			return temp.toUri().toString();
		}
		else {
			return content;
		}
	}

}
