package com.webonlineapp.content;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;

import com.hyjavastock.chart.Highstock;

public class HighchartStockContent {
	private boolean emitURL = false;
	
	
	/**
	 * 
	 */
	public HighchartStockContent() {
		
	}
	
	/**
	 * 
	 * @param emitURL
	 */
	public HighchartStockContent(boolean emitURL) {
		this.emitURL = emitURL;
	}

	/**
	 * 
	 * @param chart
	 * @return
	 */
	public String build(Highstock chart, boolean es5) {
		String content = 
			"<!DOCTYPE html>" + System.lineSeparator() + 				// html5
			"<html>" + System.lineSeparator() + 						// start html
			"<head>" + System.lineSeparator() +							// start head
			"<title>chart</title>"+ System.lineSeparator() +			// title
			"</head>" + System.lineSeparator() +						// end head
				   
			"<body>" + System.lineSeparator() +							// start body
			"<div id=\"container\" style=\"min-width: 310px; max-width: 800px; height: 400px; margin: 0 auto\"></div>" + System.lineSeparator() +
				   
			 "<script src=https://code.highcharts.com/stock/11.4.0/" + (es5 ? "es5/" : "") + "highstock.js></script>" + System.lineSeparator() +
			 "<script src=https://code.highcharts.com/stock/11.4.0/" + (es5 ? "es5/" : "") + "modules/data.js></script>" + System.lineSeparator() +
				   
			"<script>" + System.lineSeparator() +
				(chart.globalOptionsToJs() == null ? "" : "Highcharts.setOptions(" + chart.globalOptionsToJs() + ");" + System.lineSeparator()) + 
			"Highcharts.stockChart('container', " + chart.chartOptionsToJs() + " );" + System.lineSeparator() + 
			"</script>" + System.lineSeparator() +
				   
			"</body>" + System.lineSeparator() +						// end body
			"</html>";													// end html

		if (emitURL) {
			Path temp = null;
			try {
				temp = Files.createTempFile("chart", ".html");
				Files.write(temp, content.getBytes(StandardCharsets.UTF_8));
				
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			return temp.toUri().toString();
		}
		else {
			return content;
		}
	}

}
