package com.webonlineapp.views;

import java.util.Arrays;

import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.form.Button;
import org.apache.wicket.markup.html.form.DropDownChoice;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.model.PropertyModel;

import com.hyjavaapex.chart.Apexchart;
import com.webonlineapp.charts.ApexChartsBasicColumn;

public class ApexChartsColumnPage extends WebPage {
	private static final long serialVersionUID = 1L;
	
	private String selectedChart = "ApexCharts Column";
	

	/**
	 * Build the ApexCharts column chart
	 * 
	 */
	public ApexChartsColumnPage() {
		Apexchart apexchart = new ApexChartsBasicColumn().configure();

		String chartOptionsScript = "var chart = new ApexCharts(document.querySelector('#container'), "
				+ apexchart.chartOptionsToJs() + ");" + "chart.render();";

		add(buildEntry());
		add(new Label("script", chartOptionsScript).setEscapeModelStrings(false));
	}
	
	/**
	 * 
	 * @return
	 */
	private Form<Object> buildEntry() {
	    Form<Object> form = new Form<Object>("form");
	    
		DropDownChoice<String> ddc = 
			new DropDownChoice<String>("charts", 
				new PropertyModel<String>(this, "selectedChart"), 
					Arrays.asList(new String[] {"Highcharts Line", "Highcharts Pie", "Highstock Column", "ApexCharts Column"}));
		form.add(ddc);

	    Button displayButton = new Button("display") {
			private static final long serialVersionUID = 1L;

			public void onSubmit() {
	            if (getSelectedChart().equals("Highcharts Line")) {
	            	setResponsePage(new HighchartsLinePage());
	            }
	            else if (getSelectedChart().equals("Highcharts Pie")) {
	            	setResponsePage(new HighchartsPiePage());
	            }
	            else if (getSelectedChart().equals("Highstock Column")) {
	            	setResponsePage(new HighstockColumnPage());
	            }
	            else {
	            	setResponsePage(new ApexChartsColumnPage());
	            }
	        }
	    };
	    
	    form.add(displayButton);
	    
	    return form;
	}
	

	public String getSelectedChart() {
		return selectedChart;
	}

	public void setSelectedChart(String selectedChart) {
		this.selectedChart = selectedChart;
	}
	
}
