package com.webonlineapp.hyjavastockdemo11.charts;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.webonlineapp.hyjavastockdemo11.examplecharts.*;

public class DemoCharts {

	private static final List<DemoChart> demoChartsList = new ArrayList<DemoChart>(Arrays.asList(
		// General
		new DemoChart("General"),
		new DemoChart("Stock Chart With GUI", new StockChartWithGUI()),
		new DemoChart("Flags Marking Events", new FlagsMarkingEvents()),
		new DemoChart("Intraday Candlestick", new IntraDayCandleStick()),
		new DemoChart("Intraday With Breaks", new IntraDayWithBreaks()),
		new DemoChart("Intraday Area", new IntraDayArea()),
		new DemoChart("Soundscape", new Soundscape()).setNewChart(),
		new DemoChart("Points With Data Grouping", new PointsWithDataGrouping()),
		new DemoChart("Compare Multiple Series", new CompareMultipleSeries()),
		new DemoChart("Two Panes, Candlestick", new TwoPanesCandlestick()),
		new DemoChart("Single Line Series", new SingleLineSeries()),
		new DemoChart("Cumulative Sum", new CumulativeSum()),
		new DemoChart("Dynamically Updated Data", new DynamicallyUpdatedData()),
    	
    	// Chart Types
    	new DemoChart("Chart Types"),
    	new DemoChart("Column Range", new ColumnRange()),
    	new DemoChart("Column", new Column()),
    	new DemoChart("OHLC", new OHLC()),
    	new DemoChart("Candlestick", new Candlestick()),
    	new DemoChart("Area Spline Range", new AreaSplineRange()),
    	new DemoChart("Depth Chart", new DepthChart()),
    	new DemoChart("Area Range", new AreaRange()),
    	new DemoChart("Area Spline", new AreaSpline()),
    	new DemoChart("Area", new Area()),
    	new DemoChart("Step Line", new StepLine()),
    	new DemoChart("Spline", new Spline()),
    	new DemoChart("Line With Markers And Shadow", new LineWithMarkersAndShadow()),
    	new DemoChart("Hollow Candlestick", new HollowCandlestick()),
    	new DemoChart("HLC", new HLC()),
    	new DemoChart("Heiken Ashi", new HeikenAshi()),
    	new DemoChart("Point Markers Only", new PointMarkersOnly()),
    	
    	// Various Features
    	new DemoChart("Various Features"),
    	new DemoChart("Disabled Scroll Bar", new DisabledScrollBar()),
    	new DemoChart("Styled Scroll Bar", new StyledScrollBar()),
    	new DemoChart("Reversed Y Axis", new ReversedYAxis()),
    	new DemoChart("Plot Bands On Y Axis", new PlotBandsOnYAxis()),
    	new DemoChart("Plot Lines On Y Axis", new PlotLinesOnYAxis()),
    	new DemoChart("Disabled Navigator", new DisabledNavigator()),
    	
    	// Flags and Indicators
    	new DemoChart("Flags and Indicators"),
    	new DemoChart("Flags Placement", new FlagsPlacement()),
    	new DemoChart("SMA Volume By Price", new SMAVolumeByPrice()),
    	new DemoChart("MACD Pivot Points", new MACDPivotPoints()),
    	new DemoChart("Flags Shapes And Colors", new FlagsShapesAndColors())
		));

	/**
	 * 
	 * @return
	 */
	public static final List<DemoChart> getDemoChartsList() {
		return demoChartsList;
	}

}
