package com.webonlineapp.hyjavastockdemo11.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesSpline;
import com.webonlineapp.hyjavastockdemo11.chartdata.AAPLCloseData;
import com.webonlineapp.hyjavastockdemo11.charts.DemoChartBase;

public class Spline extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);
		
		SeriesSpline seriesSpline = new SeriesSpline();
		seriesSpline.setType(SeriesType.SPLINE).setName("AAPL Stock Price");
		seriesSpline.getTooltip().setValueDecimals(2);
		seriesSpline.getDataAsJsValue().setJsValue(new AAPLCloseData().get());
		chartOptions.getSeries().add(seriesSpline);
		
		return highStock;
	}
	
}