package com.webonlineapp.hyjavastockdemo11.examplecharts;

import java.util.ArrayList;
import java.util.Arrays;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Unit;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.constants.SeriesType;
import com.hyjavastock.model.highstock.series.SeriesOhlc;
import com.webonlineapp.hyjavastockdemo11.chartdata.AAPLOpenHighLowCloseData;
import com.webonlineapp.hyjavastockdemo11.charts.DemoChartBase;

public class OHLC extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(2);
		
		SeriesOhlc seriesOhlc = new SeriesOhlc();
		seriesOhlc.setType(SeriesType.OHLC).setName("AAPL Stock Price");
		
		seriesOhlc.getDataGrouping().getUnits().add(new Unit("week", new ArrayList<Number>(Arrays.asList(1))));
		seriesOhlc.getDataGrouping().getUnits().add(new Unit("month", new ArrayList<Number>(Arrays.asList(1, 2, 3, 4, 6))));
		
		seriesOhlc.getDataAsJsValue().setJsValue(new AAPLOpenHighLowCloseData().get());
		chartOptions.getSeries().add(seriesOhlc);
		
		return highStock;
	}
	
}