package com.webonlineapp.hyjavastockdemo11.examplecharts;

import com.hyjavastock.chart.Highstock;
import com.hyjavastock.model.common.Color;
import com.hyjavastock.model.highstock.ChartOptions;
import com.hyjavastock.model.highstock.series.SeriesLine;
import com.webonlineapp.hyjavastockdemo11.chartdata.AAPLCloseData;
import com.webonlineapp.hyjavastockdemo11.charts.DemoChartBase;

public class StyledScrollBar extends DemoChartBase {
	private static final long serialVersionUID = 1L;

	public Highstock configure() {
		Highstock highStock = new Highstock();
		ChartOptions chartOptions = highStock.getChartOptions();
		
		chartOptions.getStockTools().getGui().setEnabled(false);
	    
		chartOptions.getTitle().setText("AAPL Stock Price");
		chartOptions.getRangeSelector().setSelected(1);

		chartOptions.getScrollbar()
			.setBarBackgroundColor(new Color("gray"))
			.setBarBorderRadius(7)
			.setBarBorderWidth(0)
			.setButtonBackgroundColor(new Color("gray"))
			.setButtonBorderRadius(7)
			.setButtonBorderWidth(0)
			.setTrackBackgroundColor(new Color("none"))
			.setTrackBorderRadius(8)
			.setTrackBorderWidth(1)
			.setTrackBorderColor(new Color("#CCC"));
		
		SeriesLine seriesLine = new SeriesLine();
		seriesLine.setName("AAPL");
		seriesLine.getTooltip().setValueDecimals(2);
		seriesLine.getDataAsJsValue().setJsValue(new AAPLCloseData().get());
		chartOptions.getSeries().add(seriesLine);
		
		return highStock;
	}
	
}