package com.webonlineapp;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.hyjavacharts.chart.Highchart;

/*
 * A simple proof of concept example application to show how to integrate
 * Highcharts and the HyJavaCharts library in a JSP application.
 * 
 * The Charts available are: Highcharts line and pie charts
 *
 * NOTE: The evaluation library only supports a limited set of Highcharts chart types and chart options.
 *       The full version of the HyJavaCharts library supports all Highcharts chart types and chart options.
 *
 *       We are not experts using JSP's so there will no doubt be better ways to accomplish the same thing.
 * 
 */
@WebServlet("/")
public final class DemoServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;


    /**
     * 
     */
    protected void doGet(final HttpServletRequest req, final HttpServletResponse resp)
            throws ServletException, IOException {

        handleRequest(req, resp);
    }

    /**
     * 
     */
    protected void doPost(final HttpServletRequest req, final HttpServletResponse resp)
            throws ServletException, IOException {

        handleRequest(req, resp);
    }

    /**
     * 
     * @param req
     * @param resp
     * @throws ServletException
     * @throws IOException
     */
    private void handleRequest(final HttpServletRequest req, final HttpServletResponse resp)
            throws ServletException, IOException {
     	
    	if (req.getServletPath().equals("/displaychart")) {
	     	String reqChart = req.getParameter("chartName") == null ? "Highcharts Line Chart" : req.getParameter("chartName");
	    	req.setAttribute("chartName", reqChart);
	    	
	    	String globalOptionsJs = "";
	    	String chartOptionsJs = "";
			Highchart hc = null;
				
			if (reqChart.equals("Highcharts Line Chart")) {
	    		hc = new BasicLine().configure();
	    		chartOptionsJs = hc.chartOptionsToJs();
	    	}
	    	else {
	    		hc = new PieChart().configure();
	    		chartOptionsJs = hc.chartOptionsToJs();
	    	}
	    	
	    	req.setAttribute("globalOptions", globalOptionsJs);
	        req.setAttribute("chartOptions", chartOptionsJs);
	 
	        req.getRequestDispatcher("/highchartsdemo.jsp").forward(req, resp);
	    }
    	else {
    		req.getRequestDispatcher("/home.jsp").forward(req, resp);
    	}
    }

}
